<?xml version="1.0" ?>
<!-- 
NAME
    cmkurole.xsl
DESCRIPTION
    Convert mdapi ROLE_T document to CM ROLE document
    Remove elements that do not need comparing	

MODIFIED	MM/DD/YY
    pkaliren    05/15/08 - Merge 11GC functionality
    xshen       09/20/04 - add encrypted param
    abodge      07/22/04 - Add authentication 
    abodge      07/14/04 - abodge_add_role_etc
    abodge      07/12/04 - Created
 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- Top level imports -->
<xsl:import href="cmkucommon.xsl"/>

<!-- Top level template for all objects -->
<xsl:template match="/">
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="RESULTSET | ROWSET">
 <xsl:for-each select="ROW">
  <xsl:apply-templates/>
 </xsl:for-each>
</xsl:template>

<xsl:template match="ROLE_T">
  <ROLE>
    <NAME>
      <xsl:value-of select="NAME"/>
    </NAME>
    <xsl:choose>
      <xsl:when test="PASSWORD">
        <!-- For security -->
        <xsl:apply-templates select="PASSWORD"/> 
      </xsl:when>
    </xsl:choose>
  </ROLE>
</xsl:template>

</xsl:stylesheet>
