rem  %1 DBA login id
rem  %2 password
rem  %3 database name 
rem  %4 database server name
rem  %5 end or column delimiter
rem  %6 end of row delimiter

echo OfflinePluginIdentifier=oracle.dbtools.migration.workbench.plugin.SQLServer2000Plugin>sqlserver2000.ocp

rem store the delimiters
bcp "select '%5' " queryout COLUMN.TXT -c -e COLUMN.ERR -t "" -r "" -U%1 -P%2 -S%4
bcp "select '%6' " queryout ROW.TXT -c -e ROW.ERR -t "" -r "" -U%1 -P%2 -S%4


rem export the required system tables in the master database
bcp "select CONVERT(Image,sid), '%5', status, '%5', CONVERT(CHAR(50), createdate, 111), '%5', CONVERT(CHAR(50), updatedate, 111), '%5', CONVERT(CHAR(50), accdate, 111), '%5', totcpu, '%5', totio, '%5', spacelimit, '%5', timelimit, '%5', resultlimit, '%5', CAST(name AS VARCHAR(128)), '%5', CAST(dbname AS VARCHAR(128)), '%5', CAST(' ' AS VARCHAR(256)), '%5', CAST(language AS VARCHAR(128)), '%5', denylogin, '%5', hasaccess, '%5', isntname, '%5', isntgroup, '%5', isntuser, '%5', sysadmin, '%5', securityadmin, '%5', serveradmin, '%5', setupadmin, '%5', processadmin, '%5', diskadmin, '%5', dbcreator, '%5', bulkadmin, '%5', CAST(loginname AS VARCHAR(128)), '%5', '%6' from master.dbo.syslogins" queryout master\SS2K_SYSLOGINS.dat -c -e master\SS2K_SYSLOGINS.ERR -U%1 -P%2 -S%4
bcp "select CAST(name AS VARCHAR(128)), '%5', dbid, '%5', CONVERT(Image,sid), '%5', mode, '%5', status, '%5', status2, '%5', CONVERT(VARCHAR(50), crdate, 111), '%5', CONVERT(VARCHAR(50), reserved, 111), '%5', category, '%5', cmptlevel, '%5', CAST(filename AS VARCHAR(260)), '%5', version, '%5', '%6' from master.dbo.sysdatabases" queryout master\SS2K_SYSDATABASES.dat -c -e master\SS2K_SYSDATABASES.ERR -U%1 -P%2 -S%4

rem export the required system tables in the database to be migrated
bcp "select uid, '%5', status, '%5', CAST(name AS VARCHAR(128)), '%5', CONVERT(Image, sid), '%5', CONVERT(Image,roles), '%5', CONVERT(CHAR(50), createdate, 111), '%5', CONVERT(CHAR(50), updatedate, 111), '%5', altuid, '%5', CONVERT(Image, password), '%5', gid, '%5', CAST(environ AS VARCHAR(255)), '%5', hasdbaccess, '%5', islogin, '%5', isntname, '%5', isntgroup, '%5', isntuser, '%5', issqluser, '%5', isaliased, '%5', issqlrole, '%5', isapprole, '%5', '%6'  from %3.dbo.sysusers" queryout %3\SS2K_SYSUSERS.dat -c -e %3\SS2K_SYSUSERS.ERR -U%1 -P%2 -S%4
bcp "select id, '%5', grantee, '%5', grantor, '%5', actadd, '%5', actmod, '%5', CONVERT(Image,seladd), '%5', CONVERT(Image, selmod), '%5',CONVERT(Image, updadd), '%5',CONVERT(Image, updmod), '%5', CONVERT(Image, refadd), '%5',CONVERT(Image, refmod), '%5', '%6'   from %3.dbo.syspermissions" queryout %3\SS2K_SYSPERMISSIONS.dat -c -e %3\SS2K_SYSPERMISSIONS.ERR -U%1 -P%2 -S%4
bcp "select id, '%5', uid, '%5', action, '%5', protecttype, '%5', CONVERT(Image, columns), '%5', grantor, '%5', '%6'  from %3.dbo.sysprotects" queryout %3\SS2K_SYSPROTECTS.dat -c -e %3\SS2K_SYSPROTECTS.ERR -U%1 -P%2 -S%4
bcp "select CAST(name AS VARCHAR(128)), '%5', id, '%5', CAST(xtype AS VARCHAR(2)), '%5', uid, '%5', info, '%5', status, '%5', base_schema_ver, '%5', replinfo, '%5', parent_obj, '%5', CONVERT(CHAR(50), crdate, 111), '%5', ftcatid, '%5', schema_ver, '%5', stats_schema_ver, '%5', CAST(type AS VARCHAR(2)), '%5', userstat, '%5', sysstat, '%5', indexdel, '%5', CONVERT(CHAR(50), refdate, 111), '%5', version, '%5', deltrig, '%5', instrig, '%5', updtrig, '%5', seltrig, '%5', category, '%5', cache, '%5', '%6' from %3.dbo.sysobjects where name <> 'dtproperties'" queryout %3\SS2K_SYSOBJECTS.dat -c -e %3\SS2K_SYSOBJECTS.ERR -U%1 -P%2 -S%4
bcp "select CAST(name AS VARCHAR(128)), '%5', id, '%5', xtype, '%5', typestat, '%5', xusertype, '%5', length, '%5', xprec, '%5', xscale, '%5', colid, '%5', xoffset, '%5', bitpos, '%5', reserved, '%5', colstat, '%5', cdefault, '%5', domain, '%5', number, '%5', colorder, '%5', offset, '%5', collationid, '%5', language, '%5', status, '%5', type, '%5', usertype, '%5', ' ', '%5', prec, '%5', scale, '%5', iscomputed, '%5', isoutparam, '%5', isnullable, '%5', CAST(collation AS VARCHAR(128)), '%5', CONVERT(Image, tdscollation), '%5', '%6' from %3.dbo.syscolumns" queryout %3\SS2K_SYSCOLUMNS.dat -c -e %3\SS2K_SYSCOLUMNS.ERR -U%1 -P%2 -S%4
bcp "select CAST(name AS VARCHAR(128)), '%5', xtype, '%5', status, '%5', xusertype, '%5', length, '%5', xprec, '%5', xscale, '%5', tdefault, '%5', domain, '%5', uid, '%5', reserved, '%5', collationid, '%5', usertype, '%5', variable, '%5', allownulls, '%5', type, '%5', CAST(printfmt AS VARCHAR(255)), '%5', prec, '%5', scale, '%5', CAST(collation AS VARCHAR(128)), '%5', '%6'  from %3.dbo.systypes" queryout %3\SS2K_SYSTYPES.dat -c -e %3\SS2K_SYSTYPES.ERR -U%1 -P%2 -S%4
bcp "select id, '%5', status, '%5', CONVERT(Image, first), '%5', indid, '%5', CONVERT(Image,root), '%5', minlen, '%5', keycnt, '%5', groupid, '%5', dpages, '%5', reserved, '%5', used, '%5', rowcnt, '%5', rowmodctr, '%5', reserved3, '%5', reserved4, '%5', xmaxlen, '%5', maxirow, '%5', OrigFillFactor, '%5', StatVersion, '%5', reserved2, '%5', CONVERT(Image, FirstIAM), '%5', impid, '%5', lockflags, '%5', pgmodctr, '%5', CONVERT(Image, keys), '%5', CAST(name AS VARCHAR(128)), '%5', NULL, '%5', maxlen, '%5', rows, '%5', '%6'  from %3.dbo.sysindexes" queryout %3\SS2K_SYSINDEXES.dat -c -e %3\SS2K_SYSINDEXES.ERR -U%1 -P%2 -S%4
bcp "select id, '%5', indid, '%5', colid, '%5', keyno, '%5', '%6'  from %3.dbo.sysindexkeys" queryout %3\SS2K_SYSINDEXKEYS.dat -c -e %3\SS2K_SYSINDEXKEYS.ERR -U%1 -P%2 -S%4
bcp "select constid, '%5', fkeyid, '%5', rkeyid, '%5', rkeyindid, '%5', keycnt, '%5', CONVERT(Image, forkeys), '%5', CONVERT(Image, refkeys), '%5', fkeydbid, '%5', rkeydbid, '%5', fkey1, '%5', fkey2, '%5', fkey3, '%5', fkey4, '%5', fkey5, '%5', fkey6, '%5', fkey7, '%5', fkey8, '%5', fkey9, '%5', fkey10, '%5', fkey11, '%5', fkey12, '%5', fkey13, '%5', fkey14, '%5', fkey15, '%5', fkey16, '%5', rkey1, '%5', rkey2, '%5', rkey3, '%5', rkey4, '%5', rkey5, '%5', rkey6, '%5', rkey7, '%5', rkey8, '%5', rkey9, '%5', rkey10, '%5', rkey11, '%5', rkey12, '%5', rkey13, '%5', rkey14, '%5', rkey15, '%5', rkey16, '%5', '%6' from %3.dbo.sysreferences" queryout %3\SS2K_SYSREFERENCES.dat -c -e %3\SS2K_SYSREFERENCES.ERR -U%1 -P%2 -S%4
bcp "select constid, '%5', id, '%5', colid, '%5', spare1, '%5', status, '%5', actions, '%5', error, '%5', '%6' from %3.dbo.sysconstraints" queryout %3\SS2K_SYSCONSTRAINTS.dat -c -e %3\SS2K_SYSCONSTRAINTS.ERR -U%1 -P%2 -S%4
bcp "select id, '%5', number, '%5', colid, '%5', status, '%5', texttype, '%5', language, '%5', encrypted, '%5', compressed, '%5', CASE WHEN (encrypted = 1) then '/* ddl not accessible */' else  CAST(text AS VARCHAR(4000)) end, '%5', '%6' from %3.dbo.syscomments" queryout %3\SS2K_SYSCOMMENTS.dat -c -e %3\SS2K_SYSCOMMENTS.ERR -U%1 -P%2 -S%4
bcp "select fileid, '%5', groupid, '%5', size, '%5', maxsize, '%5', growth, '%5', status, '%5', perf, '%5', CAST(name AS VARCHAR(128)), '%5', CAST(filename AS VARCHAR(260)), '%5', '%6' from %3.dbo.sysfiles" queryout %3\SS2K_SYSFILES.dat -c -e %3\SS2K_SYSFILES.ERR -U%1 -P%2 -S%4
bcp "select memberuid, '%5', groupuid, '%5', '%6' from %3.dbo.sysmembers" queryout %3\SS2K_SYSMEMBERS.dat -c -e %3\SS2K_SYSMEMBERS.ERR -U%1 -P%2 -S%4
bcp "select constid, '%5', fkeyid, '%5', rkeyid, '%5', fkey, '%5', rkey, '%5', keyno, '%5', '%6' from %3.dbo.sysforeignkeys" queryout %3\SS2K_SYSFOREIGNKEYS.dat -c -e %3\SS2K_SYSFOREIGNKEYS.ERR -U%1 -P%2 -S%4
bcp "select id, '%5', smallid, '%5', type, '%5', name, '%5', value, '%5', '%6' from %3.dbo.sysproperties" queryout %3\SS2K_SYSPROPERTIES.dat -c -e %3\SS2K_SYSPROPERTIES.ERR -U%1 -P%2 -S%4




