
------------------------ join graph ---------------------------

"query_blocks_at_offset": [query_block) query_block &
[query_block <= :offset & :offset <= query_block)
; 

"narrowest qb" : /\query_block("query_blocks_at_offset");

-- SELECT *
--   FROM 
--       ORAPERF.S_PARTY T1, <-- full table ref
--       S_EVT_ACT T18,      <-- full table ref
--       T20                 <-- "simple table ref"
"simple table ref": 
[query_block) query_block &
query_block < alias &
[alias) table_reference &
[alias) identifier 
;
"full table ref": 
[query_block) query_block &
query_block < alias &
[alias-1) query_table_expression &
[alias) identifier 
;


"table aliases in blocks" : "full table ref" | "simple table ref"
; 

--"[alias queryblock]": ?alias='false' & ?query_block='false';

"table_alias in narrowest qb" : /\query_block("table aliases in blocks" /*| "[alias queryblock]"*/ ) 
                                & "narrowest qb"
;


"column_expr" :
[binary_condition) simple_comparison_condition &
cexpr^ = binary_condition & -- redundant
[cexpr^) simple_comparison_condition &
[cexpr) expr &
cexpr < talias &
[talias) identifier &
[talias+1) '.' &
(cname^ = cexpr | cname^^ = cexpr) &
--([cname^) expr | [cname^^) expr)& 
[cname) identifier &
--! [cname+1) '.' &
"narrowest qb".query_block < cexpr 
;

ce1 : "column_expr";
ce2 : "column_expr";

"join_condition" :
ce1.binary_condition = ce2.binary_condition &
ce1.cexpr) <= [ce2.cexpr 
--!ce1.talias = ce2.talias
;

----------------------select list----------------------

"* in qb" : [select_list) '*' 
   &  [select_list^) select_clause
   & [query_block) query_block
   & query_block < select_list
;

"*": /\query_block("* in qb");

----------------------mismatched gby------------------- 

"columns&select_list&top_select_list":
     [top_select_list) select_list 
   & [top_select_list^) select_clause   
   & [column) column
   & top_select_list < column
   & [select_list) select_list 
   & column^ = select_list
;

--problematic although formally legit: there are no unary predicates!
--"[column top_select_list]" : column)<[column  & top_select_list)<[top_select_list;

"[column top_select_list]": ?column='false' & ?top_select_list='false';

"columns&top_select_list": "columns&select_list&top_select_list" | "[column top_select_list]";

/* doesn't work anymore TODO: fix, or better yet introduce empty predicate syntax
"columns&top_select_list": -- do projection here with vacuous predicate
    "columns&select_list&top_select_list".top_select_list < "columns&select_list&top_select_list".column 
;
*/

"select columns": /\top_select_list("columns&top_select_list");

"aggregate columns" : 
   ([aggr) aggregate_function | [aggr) count | [aggr) listagg)
   & aggr < "select columns".column 
;

"aggr&top_select_list" : 
   ([aggr) aggregate_function | [aggr) count | [aggr) listagg)
   & "select columns".top_select_list < aggr 
;

"aggregate expr": /\top_select_list("aggr&top_select_list");

"matching gby": 
   [group_by_list) group_by_list
   & [group_by_list^) group_by_clause
   & "select columns".top_select_list^^ = group_by_list^^
;

"matching from": --  insertion point in case of missing gby
   [insertion_point) from_clause
   & "select columns".top_select_list^^ = insertion_point^
;
"matching where": -- alternative insertion point in case of missing gby
   [insertion_point) where_clause
   & "select columns".top_select_list^^ = insertion_point^
;
"insertion point": \/insertion_point("matching from"|"matching where");


columns:
   "select columns"   
   -   
   "aggregate columns" 
;

"gby columns":
   [column) group_by_col
   & "matching gby".group_by_list < column
;
