--------------------------------------------------------------------------------
-- DROP EXISTING TEST DATA TABLES
--------------------------------------------------------------------------------

begin
  execute immediate 'DROP TABLE DETAIL';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DETAIL';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE MASTER';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTER_ORIGINAL';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAIL_ORIGINAL';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTER_ADD_M';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAIL_ADD_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTER_ADD_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAIL_ADD_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTER_CHG_M';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAIL_CHG_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTER_CHG_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAIL_CHG_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAIL_DEL_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTER_DEL_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DETAILX';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE MASTERX';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTERX_ORIGINAL';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAILX_ORIGINAL';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTERX_ADD_M';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAILX_ADD_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTERX_ADD_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAILX_ADD_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTERX_CHG_M';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAILX_CHG_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTERX_CHG_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAILX_CHG_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_DETAILX_DEL_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

begin
  execute immediate 'DROP TABLE DATA_MASTERX_DEL_M_D';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

--------------------------------------------------------------------------------
-- DATA TYPES USED FOR TESTING COMPLEX TYPE SUPPORT
--------------------------------------------------------------------------------

CREATE OR REPLACE TYPE SQL_NTAB IS TABLE OF VARCHAR2(128)
/

CREATE OR REPLACE TYPE SQL_VARR IS VARRAY(16) OF VARCHAR2(128)
/

CREATE OR REPLACE TYPE SQL_OBJ IS OBJECT (
    OBJ_1 INTEGER,
    OBJ_2 VARCHAR2(32)
)
/

CREATE OR REPLACE PACKAGE TYPES IS
    TYPE PLSQL_NTAB IS TABLE OF VARCHAR2(128);
    TYPE PLSQL_VARR IS VARRAY(16) OF VARCHAR2(128);
    TYPE PLSQL_ATAB IS TABLE OF VARCHAR2(128) INDEX BY PLS_INTEGER;
    TYPE PLSQL_REC IS RECORD (
        REC_1 INTEGER,
        REC_2 VARCHAR2(32)
    );
    TYPE PLSQL_CURSOR IS REF CURSOR;
END;
/

--------------------------------------------------------------------------------
-- PROCEDURES FOR TESTING PASSING INPUT PARAMETERS OF EACH TYPE
--------------------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE NULL_PROC IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE VARCHAR2_IN_PROC(P1 IN VARCHAR2) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE NUMBER_IN_PROC(P1 IN NUMBER) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE SQLNTAB_IN_PROC(P1 IN SQL_NTAB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE SQL_VARR_IN_PROC(P1 IN SQL_VARR) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE SQL_OBJ_IN_PROC(P1 IN SQL_OBJ) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_NTAB_IN_PROC(P1 IN TYPES.PLSQL_NTAB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_VARR_IN_PROC(P1 IN TYPES.PLSQL_VARR) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_ATAB_IN_PROC(P1 IN TYPES.PLSQL_ATAB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_REC_IN_PROC(P1 IN TYPES.PLSQL_REC) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_CURSOR_IN_PROC(P1 IN TYPES.PLSQL_CURSOR) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE BOOLEAN_IN_PROC(P1 IN BOOLEAN) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE CLOB_IN_PROC(P1 IN CLOB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE DATE_IN_PROC(P1 IN DATE) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE BLOB_IN_PROC(P1 IN BLOB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE NVARCHAR2_IN_PROC(P1 IN NVARCHAR2) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_INTEGER_IN_PROC(P1 IN BINARY_INTEGER) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE RAW_IN_PROC(P1 IN RAW) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE FLOAT_IN_PROC(P1 IN FLOAT) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_DOUBLE_IN_PROC(P1 IN BINARY_DOUBLE) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_FLOAT_IN_PROC(P1 IN BINARY_FLOAT) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE CHAR_IN_PROC(P1 IN CHAR) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE INTERVALDS_IN_PROC(P1 IN INTERVAL DAY TO SECOND) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE INTERVALYM_IN_PROC(P1 IN INTERVAL YEAR TO MONTH) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE RAW_IN_PROC(P1 IN RAW) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE ROWID_IN_PROC(P1 IN ROWID) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMP_IN_PROC(P1 IN TIMESTAMP) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMPLTZ_IN_PROC(P1 IN TIMESTAMP WITH LOCAL TIME ZONE ) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMPTZ_IN_PROC(P1 IN TIMESTAMP WITH TIME ZONE) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE CHAR_VAR_IN_PROC(P1 IN CHAR VARYING) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE CHARACTER_IN_PROC(P1 IN CHARACTER) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE CHARACTER_VAR_IN_PROC(P1 IN CHARACTER VARYING) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE DEC_IN_PROC(P1 IN DEC) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE DECIMAL_IN_PROC(P1 IN DECIMAL) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE DOUBLE_PRECISION_IN_PROC(P1 IN DOUBLE PRECISION) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE DSINTERVAL_UNCONS_IN_PROC(P1 IN DSINTERVAL_UNCONSTRAINED) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE INT_IN_PROC(P1 IN INT) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE INTEGER_IN_PROC(P1 IN INTEGER) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE LONG_IN_PROC(P1 IN LONG) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE LONG_RAW_IN_PROC(P1 IN LONG RAW) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHAR_IN_PROC(P1 IN NATIONAL CHAR) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHAR_VAR_IN_PROC(P1 IN NATIONAL CHAR VARYING) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHARACTER_IN_PROC(P1 IN NATIONAL CHARACTER) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHARACTER_VAR_IN_PROC(P1 IN NATIONAL CHARACTER VARYING) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NATURAL_IN_PROC(P1 IN NATURAL) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NATURALN_IN_PROC(P1 IN NATURALN) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NCHAR_IN_PROC(P1 IN NCHAR) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NCHAR_VAR_IN_PROC(P1 IN NCHAR VARYING) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NCLOB_IN_PROC(P1 IN NCLOB) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE NUMERIC_IN_PROC(P1 IN NUMERIC) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE PLS_INTEGER_IN_PROC(P1 IN PLS_INTEGER) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE POSITIVE_IN_PROC(P1 IN POSITIVE) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE POSITIVEN_IN_PROC(P1 IN POSITIVEN) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE REAL_IN_PROC(P1 IN REAL) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE SIGNTYPE_IN_PROC(P1 IN SIGNTYPE) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE SIMPLE_INTEGER_IN_PROC(P1 IN SIMPLE_INTEGER) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE SMALLINT_IN_PROC(P1 IN SMALLINT) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE TS_LTZ_UNCONS_IN_PROC(P1 IN TIMESTAMP_LTZ_UNCONSTRAINED) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE TS_TZ_UNCONS_IN_PROC(P1 IN TIMESTAMP_TZ_UNCONSTRAINED) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE TS_UNCONS_IN_PROC(P1 IN TIMESTAMP_UNCONSTRAINED) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE VARCHAR_IN_PROC(P1 IN VARCHAR) IS
BEGIN
    NULL;
END;
/
 
CREATE OR REPLACE PROCEDURE YMINT_UNCONS_IN_PROC(P1 IN YMINTERVAL_UNCONSTRAINED) IS
BEGIN
    NULL;
END;
/

--------------------------------------------------------------------------------
-- PROCEDURES FOR TESTING INOUT PARAMETERS
--------------------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE VARCHAR2_INOUT_PROC(P1 IN OUT VARCHAR2) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE NUMBER_INOUT_PROC(P1 IN OUT NUMBER) IS
BEGIN
    P1 := P1 + 1;
END;
/

CREATE OR REPLACE PROCEDURE SQLNTAB_INOUT_PROC(P1 IN OUT SQL_NTAB) IS
BEGIN
    P1.EXTEND;
    P1(P1.LAST) := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE SQL_VARR_INOUT_PROC(P1 IN OUT SQL_VARR) IS
BEGIN
    P1.EXTEND;
    P1(P1.LAST) := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE SQL_OBJ_INOUT_PROC(P1 IN OUT SQL_OBJ) IS
BEGIN
    P1.OBJ_1 := P1.OBJ_1 + 1;
    P1.OBJ_2 := P1.OBJ_2 || 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_NTAB_INOUT_PROC(P1 IN OUT TYPES.PLSQL_NTAB) IS
BEGIN
    P1.EXTEND;
    P1(P1.LAST) := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_VARR_INOUT_PROC(P1 IN OUT TYPES.PLSQL_VARR) IS
BEGIN
    P1.EXTEND;
    P1(P1.LAST) := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_ATAB_INOUT_PROC(P1 IN OUT TYPES.PLSQL_ATAB) IS
BEGIN
    P1(P1.LAST + 1) := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_REC_INOUT_PROC(P1 IN OUT TYPES.PLSQL_REC) IS
BEGIN
    P1.REC_1 := P1.REC_1 + 1;
    P1.REC_2 := P1.REC_2 || 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_CURSOR_INOUT_PROC(P1 IN OUT TYPES.PLSQL_CURSOR) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE BOOLEAN_INOUT_PROC(P1 IN OUT BOOLEAN) IS
BEGIN
    P1 := NOT P1;
END;
/

CREATE OR REPLACE PROCEDURE CLOB_INOUT_PROC(P1 IN OUT CLOB) IS
BEGIN
    DBMS_LOB.APPEND(P1, 'PLUS');
END;
/

CREATE OR REPLACE PROCEDURE DATE_INOUT_PROC(P1 IN OUT DATE) IS
BEGIN
    P1 := P1 + 1;
END;
/

CREATE OR REPLACE PROCEDURE BLOB_INOUT_PROC(P1 IN OUT BLOB) IS
BEGIN
    DBMS_LOB.APPEND(P1, TO_BLOB('0123'));
END;
/

CREATE OR REPLACE PROCEDURE NVARCHAR2_INOUT_PROC(P1 IN OUT NVARCHAR2) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE BINARY_INTEGER_INOUT_PROC(P1 IN OUT BINARY_INTEGER) IS
BEGIN
    P1 := P1 + 1;
END;
/

CREATE OR REPLACE PROCEDURE RAW_INOUT_PROC(P1 IN OUT RAW) IS
BEGIN
    P1 := P1 || '0123';
END;
/

CREATE OR REPLACE PROCEDURE FLOAT_INOUT_PROC(P1 IN OUT FLOAT) IS
BEGIN
    P1 := P1 + 1.0;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_DOUBLE_INOUT_PROC(P1 IN OUT BINARY_DOUBLE) IS
BEGIN
    P1 := P1 + 1.0;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_FLOAT_INOUT_PROC(P1 IN OUT BINARY_FLOAT) IS
BEGIN
    P1 := P1 + 1.0;
END;
/

CREATE OR REPLACE PROCEDURE CHAR_INOUT_PROC(P1 IN OUT CHAR) IS 
    BUFF VARCHAR2(32767); 
BEGIN 
    FOR C IN 1..LENGTH(TRIM(P1)) 
    LOOP 
        BUFF := BUFF || 'C'; 
    END LOOP; 
    P1 := TRIM(BUFF); 
END;
/

CREATE OR REPLACE PROCEDURE INTERVALDS_INOUT_PROC(P1 IN OUT INTERVAL DAY TO SECOND) IS
BEGIN
    P1 := P1 + INTERVAL '1' DAY;
END;
/

CREATE OR REPLACE PROCEDURE INTERVALYM_INOUT_PROC(P1 IN OUT INTERVAL YEAR TO MONTH) IS
BEGIN
    P1 := P1 + INTERVAL '1' YEAR;
END;
/

CREATE OR REPLACE PROCEDURE RAW_INOUT_PROC(P1 IN OUT RAW) IS
BEGIN
    P1 := P1 || '0123';
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMP_INOUT_PROC(P1 IN OUT TIMESTAMP) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMPLTZ_INOUT_PROC(P1 IN OUT TIMESTAMP WITH LOCAL TIME ZONE ) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMPTZ_INOUT_PROC(P1 IN OUT TIMESTAMP WITH TIME ZONE) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
END;
/

CREATE OR REPLACE PROCEDURE CHAR_VAR_INOUT_PROC(P1 IN OUT CHAR VARYING) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE CHARACTER_INOUT_PROC(P1 IN OUT CHARACTER) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE CHARACTER_VAR_INOUT_PROC(P1 IN OUT CHARACTER VARYING) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE DEC_INOUT_PROC(P1 IN OUT DEC) IS
BEGIN
    P1 := P1 + 1.0;
END;
/
 
CREATE OR REPLACE PROCEDURE DECIMAL_INOUT_PROC(P1 IN OUT DECIMAL) IS
BEGIN
    P1 := P1 + 1.0;
END;
/
 
CREATE OR REPLACE PROCEDURE DOUBLE_PRECISION_INOUT_PROC(P1 IN OUT DOUBLE PRECISION) IS
BEGIN
    P1 := P1 + 1.0;
END;
/
 
CREATE OR REPLACE PROCEDURE DSINTERVAL_UNCONS_INOUT_PROC(P1 IN OUT DSINTERVAL_UNCONSTRAINED) IS
BEGIN
    P1 := P1 + INTERVAL '1' DAY;
END;
/
 
CREATE OR REPLACE PROCEDURE INT_INOUT_PROC(P1 IN OUT INT) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE INTEGER_INOUT_PROC(P1 IN OUT INTEGER) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE LONG_INOUT_PROC(P1 IN OUT LONG) IS
BEGIN
    P1 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE LONG_RAW_INOUT_PROC(P1 IN OUT LONG RAW) IS
BEGIN
    P1 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHAR_INOUT_PROC(P1 IN OUT NATIONAL CHAR) IS
    BUFF VARCHAR2(32767); 
BEGIN 
    FOR C IN 1..LENGTH(TRIM(P1)) 
    LOOP 
        BUFF := BUFF || 'C'; 
    END LOOP; 
    P1 := TRIM(BUFF); 
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHAR_VAR_INOUT_PROC(P1 IN OUT NATIONAL CHAR VARYING) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHARACTER_INOUT_PROC(P1 IN OUT NATIONAL CHARACTER) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHARACTER_VAR_INOUT_PROC(P1 IN OUT NATIONAL CHARACTER VARYING) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE NATURAL_INOUT_PROC(P1 IN OUT NATURAL) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE NATURALN_INOUT_PROC(P1 IN OUT NATURALN) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE NCHAR_INOUT_PROC(P1 IN OUT NCHAR) IS
    BUFF VARCHAR2(32767); 
BEGIN 
    FOR C IN 1..LENGTH(TRIM(P1)) 
    LOOP 
        BUFF := BUFF || 'C'; 
    END LOOP; 
    P1 := TRIM(BUFF); 
END;
/
 
CREATE OR REPLACE PROCEDURE NCHAR_VAR_INOUT_PROC(P1 IN OUT NCHAR VARYING) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE NCLOB_INOUT_PROC(P1 IN OUT NCLOB) IS
BEGIN
    DBMS_LOB.APPEND(P1, 'PLUS');
END;
/
 
CREATE OR REPLACE PROCEDURE NUMERIC_INOUT_PROC(P1 IN OUT NUMERIC) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE PLS_INTEGER_INOUT_PROC(P1 IN OUT PLS_INTEGER) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE POSITIVE_INOUT_PROC(P1 IN OUT POSITIVE) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE POSITIVEN_INOUT_PROC(P1 IN OUT POSITIVEN) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE REAL_INOUT_PROC(P1 IN OUT REAL) IS
BEGIN
    P1 := P1 + 1.0;
END;
/
 
CREATE OR REPLACE PROCEDURE SIGNTYPE_INOUT_PROC(P1 IN OUT SIGNTYPE) IS
BEGIN
    P1 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE SIMPLE_INTEGER_INOUT_PROC(P1 IN OUT SIMPLE_INTEGER) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE SMALLINT_INOUT_PROC(P1 IN OUT SMALLINT) IS
BEGIN
    P1 := P1 + 1;
END;
/
 
CREATE OR REPLACE PROCEDURE TS_LTZ_UNCONS_INOUT_PROC(P1 IN OUT TIMESTAMP_LTZ_UNCONSTRAINED) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
END;
/
 
CREATE OR REPLACE PROCEDURE TS_TZ_UNCONS_INOUT_PROC(P1 IN OUT TIMESTAMP_TZ_UNCONSTRAINED) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
END;
/
 
CREATE OR REPLACE PROCEDURE TS_UNCONS_INOUT_PROC(P1 IN OUT TIMESTAMP_UNCONSTRAINED) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
END;
/
 
CREATE OR REPLACE PROCEDURE VARCHAR_INOUT_PROC(P1 IN OUT VARCHAR) IS
BEGIN
    P1 := P1 || 'PLUS';
END;
/
 
CREATE OR REPLACE PROCEDURE YMINT_UNCONS_INOUT_PROC(P1 IN OUT YMINTERVAL_UNCONSTRAINED) IS
BEGIN
    P1 := P1 + INTERVAL '1' YEAR;
END;
/

--------------------------------------------------------------------------------
-- PROCEDURES FOR TESTING OUT PARAMETERS
--------------------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE VARCHAR2_OUT_PROC(P1 IN VARCHAR2, P2 OUT VARCHAR2) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE NUMBER_OUT_PROC(P1 IN NUMBER, P2 OUT NUMBER) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE SQLNTAB_OUT_PROC(P1 IN SQL_NTAB, P2 OUT SQL_NTAB) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE SQL_VARR_OUT_PROC(P1 IN SQL_VARR, P2 OUT SQL_VARR) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE SQL_OBJ_OUT_PROC(P1 IN SQL_OBJ, P2 OUT SQL_OBJ) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_NTAB_OUT_PROC(P1 IN TYPES.PLSQL_NTAB, P2 OUT TYPES.PLSQL_NTAB) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_VARR_OUT_PROC(P1 IN TYPES.PLSQL_VARR, P2 OUT TYPES.PLSQL_VARR) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_ATAB_OUT_PROC(P1 IN TYPES.PLSQL_ATAB, P2 OUT TYPES.PLSQL_ATAB) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_REC_OUT_PROC(P1 IN TYPES.PLSQL_REC, P2 OUT TYPES.PLSQL_REC) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_CURSOR_OUT_PROC(P1 IN TYPES.PLSQL_CURSOR, P2 OUT TYPES.PLSQL_CURSOR) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE BOOLEAN_OUT_PROC(P1 IN BOOLEAN, P2 OUT BOOLEAN) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE CLOB_OUT_PROC(P1 IN CLOB, P2 OUT CLOB) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE DATE_OUT_PROC(P1 IN DATE, P2 OUT DATE) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE BLOB_OUT_PROC(P1 IN BLOB, P2 OUT BLOB) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE NVARCHAR2_OUT_PROC(P1 IN NVARCHAR2, P2 OUT NVARCHAR2) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_INTEGER_OUT_PROC(P1 IN BINARY_INTEGER, P2 OUT BINARY_INTEGER) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE RAW_OUT_PROC(P1 IN RAW, P2 OUT RAW) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE FLOAT_OUT_PROC(P1 IN FLOAT, P2 OUT FLOAT) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_DOUBLE_OUT_PROC(P1 IN BINARY_DOUBLE, P2 OUT BINARY_DOUBLE) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE BINARY_FLOAT_OUT_PROC(P1 IN BINARY_FLOAT, P2 OUT BINARY_FLOAT) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE CHAR_OUT_PROC(P1 IN CHAR, P2 OUT CHAR) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE INTERVALDS_OUT_PROC(P1 IN INTERVAL DAY TO SECOND, P2 OUT INTERVAL DAY TO SECOND) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE INTERVALYM_OUT_PROC(P1 IN INTERVAL YEAR TO MONTH, P2 OUT INTERVAL YEAR TO MONTH) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE RAW_OUT_PROC(P1 IN RAW, P2 OUT RAW) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMP_OUT_PROC(P1 IN TIMESTAMP, P2 OUT TIMESTAMP) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMPLTZ_OUT_PROC(P1 IN TIMESTAMP WITH LOCAL TIME ZONE, P2 OUT TIMESTAMP WITH LOCAL TIME ZONE) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE TIMESTAMPTZ_OUT_PROC(P1 IN TIMESTAMP WITH TIME ZONE, P2 OUT TIMESTAMP WITH TIME ZONE) IS
BEGIN
    P2 := P1;
END;
/

CREATE OR REPLACE PROCEDURE CHAR_VAR_OUT_PROC(P1 IN CHAR VARYING, P2 OUT CHAR VARYING) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE CHARACTER_OUT_PROC(P1 IN CHARACTER, P2 OUT CHARACTER) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE CHARACTER_VAR_OUT_PROC(P1 IN CHARACTER VARYING, P2 OUT CHARACTER VARYING) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE DEC_OUT_PROC(P1 IN DEC, P2 OUT DEC) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE DECIMAL_OUT_PROC(P1 IN DECIMAL, P2 OUT DECIMAL) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE DOUBLE_PRECISION_OUT_PROC(P1 IN DOUBLE PRECISION, P2 OUT DOUBLE PRECISION) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE DSINTERVAL_UNCONS_OUT_PROC(P1 IN DSINTERVAL_UNCONSTRAINED, P2 OUT DSINTERVAL_UNCONSTRAINED) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE INT_OUT_PROC(P1 IN INT, P2 OUT INT) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE INTEGER_OUT_PROC(P1 IN INTEGER, P2 OUT INTEGER) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE LONG_OUT_PROC(P1 IN LONG, P2 OUT LONG) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE LONG_RAW_OUT_PROC(P1 IN LONG RAW, P2 OUT LONG RAW) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHAR_OUT_PROC(P1 IN NATIONAL CHAR, P2 OUT NATIONAL CHAR) IS
BEGIN 
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHAR_VAR_OUT_PROC(P1 IN NATIONAL CHAR VARYING, P2 OUT NATIONAL CHAR VARYING) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHARACTER_OUT_PROC(P1 IN NATIONAL CHARACTER, P2 OUT NATIONAL CHARACTER) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NAT_CHARACTER_VAR_OUT_PROC(P1 IN NATIONAL CHARACTER VARYING, P2 OUT NATIONAL CHARACTER VARYING) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NATURAL_OUT_PROC(P1 IN NATURAL, P2 OUT NATURAL) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NATURALN_OUT_PROC(P1 IN NATURALN, P2 OUT NATURALN) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NCHAR_OUT_PROC(P1 IN NCHAR, P2 OUT NCHAR) IS
BEGIN 
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NCHAR_VAR_OUT_PROC(P1 IN NCHAR VARYING, P2 OUT NCHAR VARYING) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NCLOB_OUT_PROC(P1 IN NCLOB, P2 OUT NCLOB) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE NUMERIC_OUT_PROC(P1 IN NUMERIC, P2 OUT NUMERIC) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE PLS_INTEGER_OUT_PROC(P1 IN PLS_INTEGER, P2 OUT PLS_INTEGER) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE POSITIVE_OUT_PROC(P1 IN POSITIVE, P2 OUT POSITIVE) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE POSITIVEN_OUT_PROC(P1 IN POSITIVEN, P2 OUT POSITIVEN) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE REAL_OUT_PROC(P1 IN REAL, P2 OUT REAL) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE SIGNTYPE_OUT_PROC(P1 IN SIGNTYPE, P2 OUT SIGNTYPE) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE SIMPLE_INTEGER_OUT_PROC(P1 IN SIMPLE_INTEGER, P2 OUT SIMPLE_INTEGER) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE SMALLINT_OUT_PROC(P1 IN SMALLINT, P2 OUT SMALLINT) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE TS_LTZ_UNCONS_OUT_PROC(P1 IN TIMESTAMP_LTZ_UNCONSTRAINED, P2 OUT TIMESTAMP_LTZ_UNCONSTRAINED) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE TS_TZ_UNCONS_OUT_PROC(P1 IN TIMESTAMP_TZ_UNCONSTRAINED, P2 OUT TIMESTAMP_TZ_UNCONSTRAINED) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE TS_UNCONS_OUT_PROC(P1 IN TIMESTAMP_UNCONSTRAINED, P2 OUT TIMESTAMP_UNCONSTRAINED) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE VARCHAR_OUT_PROC(P1 IN VARCHAR, P2 OUT VARCHAR) IS
BEGIN
    P2 := P1;
END;
/
 
CREATE OR REPLACE PROCEDURE YMINT_UNCONS_OUT_PROC(P1 IN YMINTERVAL_UNCONSTRAINED, P2 OUT YMINTERVAL_UNCONSTRAINED) IS
BEGIN
    P2 := P1;
END;
/

--------------------------------------------------------------------------------
-- PROCEDURES FOR TESTING RETURN VALUES
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION VARCHAR2_RET_FUNC(P1 IN VARCHAR2) RETURN VARCHAR2 IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION NUMBER_RET_FUNC(P1 IN NUMBER) RETURN NUMBER IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION SQLNTAB_RET_FUNC(P1 IN SQL_NTAB) RETURN SQL_NTAB IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION SQL_VARR_RET_FUNC(P1 IN SQL_VARR) RETURN SQL_VARR IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION SQL_OBJ_RET_FUNC(P1 IN SQL_OBJ) RETURN SQL_OBJ IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION PLSQL_NTAB_RET_FUNC(P1 IN TYPES.PLSQL_NTAB) RETURN TYPES.PLSQL_NTAB IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION PLSQL_VARR_RET_FUNC(P1 IN TYPES.PLSQL_VARR) RETURN TYPES.PLSQL_VARR IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION PLSQL_ATAB_RET_FUNC(P1 IN TYPES.PLSQL_ATAB) RETURN TYPES.PLSQL_ATAB IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION PLSQL_REC_RET_FUNC(P1 IN TYPES.PLSQL_REC) RETURN TYPES.PLSQL_REC IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION PLSQL_CURSOR_RET_FUNC(P1 IN TYPES.PLSQL_CURSOR) RETURN TYPES.PLSQL_CURSOR IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION BOOLEAN_RET_FUNC(P1 IN BOOLEAN) RETURN BOOLEAN IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION CLOB_RET_FUNC(P1 IN CLOB) RETURN CLOB IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION DATE_RET_FUNC(P1 IN DATE) RETURN DATE IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION BLOB_RET_FUNC(P1 IN BLOB) RETURN BLOB IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION NVARCHAR2_RET_FUNC(P1 IN NVARCHAR2) RETURN NVARCHAR2 IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION BINARY_INTEGER_RET_FUNC(P1 IN BINARY_INTEGER) RETURN BINARY_INTEGER IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION RAW_RET_FUNC(P1 IN RAW) RETURN RAW IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FLOAT_RET_FUNC(P1 IN FLOAT) RETURN FLOAT IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION BINARY_DOUBLE_RET_FUNC(P1 IN BINARY_DOUBLE) RETURN BINARY_DOUBLE IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION BINARY_FLOAT_RET_FUNC(P1 IN BINARY_FLOAT) RETURN BINARY_FLOAT IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION CHAR_RET_FUNC(P1 IN CHAR) RETURN CHAR IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION INTERVALDS_RET_FUNC(P1 IN INTERVAL DAY TO SECOND) RETURN INTERVAL DAY TO SECOND IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION INTERVALYM_RET_FUNC(P1 IN INTERVAL YEAR TO MONTH) RETURN INTERVAL YEAR TO MONTH IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION RAW_RET_FUNC(P1 IN RAW) RETURN RAW IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION TIMESTAMP_RET_FUNC(P1 IN TIMESTAMP) RETURN TIMESTAMP IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION TIMESTAMPLTZ_RET_FUNC(P1 IN TIMESTAMP WITH LOCAL TIME ZONE) RETURN TIMESTAMP WITH LOCAL TIME ZONE IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION TIMESTAMPTZ_RET_FUNC(P1 IN TIMESTAMP WITH TIME ZONE) RETURN TIMESTAMP WITH TIME ZONE IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION CHAR_VAR_RET_FUNC(P1 IN CHAR VARYING) RETURN CHAR VARYING IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION CHARACTER_RET_FUNC(P1 IN CHARACTER) RETURN CHARACTER IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION CHARACTER_VAR_RET_FUNC(P1 IN CHARACTER VARYING) RETURN CHARACTER VARYING IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION DEC_RET_FUNC(P1 IN DEC) RETURN DEC IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION DECIMAL_RET_FUNC(P1 IN DECIMAL) RETURN DECIMAL IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION DOUBLE_PRECISION_RET_FUNC(P1 IN DOUBLE PRECISION) RETURN DOUBLE PRECISION IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION DSINTERVAL_UNCONS_RET_FUNC(P1 IN DSINTERVAL_UNCONSTRAINED) RETURN DSINTERVAL_UNCONSTRAINED IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION INT_RET_FUNC(P1 IN INT) RETURN INT IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION INTEGER_RET_FUNC(P1 IN INTEGER) RETURN INTEGER IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION LONG_RET_FUNC(P1 IN LONG) RETURN LONG IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION LONG_RAW_RET_FUNC(P1 IN LONG RAW) RETURN LONG RAW IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NAT_CHAR_RET_FUNC(P1 IN NATIONAL CHAR) RETURN NATIONAL CHAR IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NAT_CHAR_VAR_RET_FUNC(P1 IN NATIONAL CHAR VARYING) RETURN NATIONAL CHAR VARYING IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NAT_CHARACTER_RET_FUNC(P1 IN NATIONAL CHARACTER) RETURN NATIONAL CHARACTER IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NAT_CHARACTER_VAR_RET_FUNC(P1 IN NATIONAL CHARACTER VARYING) RETURN NATIONAL CHARACTER VARYING IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NATURAL_RET_FUNC(P1 IN NATURAL) RETURN NATURAL IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NATURALN_RET_FUNC(P1 IN NATURALN) RETURN NATURALN IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NCHAR_RET_FUNC(P1 IN NCHAR) RETURN NCHAR IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NCHAR_VAR_RET_FUNC(P1 IN NCHAR VARYING) RETURN NCHAR VARYING IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NCLOB_RET_FUNC(P1 IN NCLOB) RETURN NCLOB IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION NUMERIC_RET_FUNC(P1 IN NUMERIC) RETURN NUMERIC IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION PLS_INTEGER_RET_FUNC(P1 IN PLS_INTEGER) RETURN PLS_INTEGER IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION POSITIVE_RET_FUNC(P1 IN POSITIVE) RETURN POSITIVE IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION POSITIVEN_RET_FUNC(P1 IN POSITIVEN) RETURN POSITIVEN IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION REAL_RET_FUNC(P1 IN REAL) RETURN REAL IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION SIGNTYPE_RET_FUNC(P1 IN SIGNTYPE) RETURN SIGNTYPE IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION SIMPLE_INTEGER_RET_FUNC(P1 IN SIMPLE_INTEGER) RETURN SIMPLE_INTEGER IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION SMALLINT_RET_FUNC(P1 IN SMALLINT) RETURN SMALLINT IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION TS_LTZ_UNCONS_RET_FUNC(P1 IN TIMESTAMP_LTZ_UNCONSTRAINED) RETURN TIMESTAMP_LTZ_UNCONSTRAINED IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION TS_TZ_UNCONS_RET_FUNC(P1 IN TIMESTAMP_TZ_UNCONSTRAINED) RETURN TIMESTAMP_TZ_UNCONSTRAINED IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION TS_UNCONS_RET_FUNC(P1 IN TIMESTAMP_UNCONSTRAINED) RETURN TIMESTAMP_UNCONSTRAINED IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION VARCHAR_RET_FUNC(P1 IN VARCHAR) RETURN VARCHAR IS
BEGIN
    RETURN P1;
END;
/
 
CREATE OR REPLACE FUNCTION YMINT_UNCONS_RET_FUNC(P1 IN YMINTERVAL_UNCONSTRAINED) RETURN YMINTERVAL_UNCONSTRAINED IS
BEGIN
    RETURN P1;
END;
/

--------------------------------------------------------------------------------
-- STANDALONE PROCEDURES WITH DIFFERENT NUMBER OF PARAMETERS
--------------------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE PROC_3_SIMPLE_PARAMS(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_3_COMPLEX_PARAMS(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_3_SIMPLE_D_PARAMS(P1 IN VARCHAR2, P2 IN OUT VARCHAR2, P3 OUT VARCHAR2) IS
BEGIN
    P2 := P2 || 'PLUS';
    P3 := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PROC_3_COMPLEX_D_PARAMS(P1 IN TIMESTAMP, P2 IN OUT SQL_VARR, P3 OUT INTERVAL YEAR TO MONTH) IS
BEGIN
    P2.EXTEND;
    P2(P2.LAST) := 'PLUS';
    P3 := INTERVAL '1' YEAR;
END;
/

CREATE OR REPLACE PROCEDURE PROC_5_SIMPLE_PARAMS(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_5_COMPLEX_PARAMS(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_5_SIMPLE_D_PARAMS(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2) IS
BEGIN
    P1 := P1 || 'PLUS';
    P2 := 'PLUS';
    P4 := P4 || 'PLUS';
    P5 := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PROC_5_COMPLEX_D_PARAMS(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
    P2 := SQL_VARR('FIRST', 'SECOND', 'THIRD');
    P4(1) := '1';
    P4(2) := '2';
    DBMS_LOB.APPEND(P5, TO_BLOB('0123'));    
END;
/

CREATE OR REPLACE PROCEDURE PROC_10_SIMPLE_PARAMS(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2,
                                                 P6 IN VARCHAR2, P7 IN VARCHAR2, P8 IN VARCHAR2, P9 IN VARCHAR2, P10 IN VARCHAR2) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_10_COMPLEX_PARAMS(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB,
                                                  P6 IN TIMESTAMP, P7 IN SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 IN TYPES.PLSQL_ATAB, P10 IN BLOB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_10_SIMPLE_D_PARAMS(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2,
                                                   P6 IN OUT VARCHAR2, P7 OUT VARCHAR2, P8 IN VARCHAR2, P9 IN OUT VARCHAR2, P10 OUT VARCHAR2) IS
BEGIN
    P1 := P1 || 'PLUS';
    P2 := 'PLUS';
    P4 := P4 || 'PLUS';
    P5 := 'PLUS';
    P6 := P6 || 'PLUS';
    P7 := 'PLUS';
    P9 := P9 || 'PLUS';
    P10 := 'PLUS';
END;
/

CREATE OR REPLACE PROCEDURE PROC_10_COMPLEX_D_PARAMS(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB,
                                                    P6 IN OUT TIMESTAMP, P7 OUT SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 OUT TYPES.PLSQL_ATAB, P10 IN OUT BLOB) IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
    P2 := SQL_VARR('FIRST', 'SECOND', 'THIRD');
    P4(1) := '1';
    P4(2) := '2';
    DBMS_LOB.APPEND(P5, TO_BLOB('0123'));    
    P6 := P6 AT TIME ZONE 'US/Pacific';
    P7 := SQL_VARR('FIRST', 'SECOND', 'THIRD');
    P9(1) := '1';
    P9(2) := '2';
    DBMS_LOB.APPEND(P10, TO_BLOB('0123'));    
END;
/

--------------------------------------------------------------------------------
-- STANDALONE FUNCTIONS WITH DIFFERENT NUMBER OF PARAMETERS
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION FUNC_3_SIMPLE_PARAMS(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2) RETURN VARCHAR2 IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_3_COMPLEX_PARAMS(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH) RETURN TIMESTAMP IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_3_SIMPLE_D_PARAMS(P1 IN VARCHAR2, P2 IN OUT VARCHAR2, P3 OUT VARCHAR2) RETURN VARCHAR2 IS
BEGIN
    P2 := P2 || 'PLUS';
    P3 := 'PLUS';
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_3_COMPLEX_D_PARAMS(P1 IN TIMESTAMP, P2 IN OUT SQL_VARR, P3 OUT INTERVAL YEAR TO MONTH) RETURN SQL_VARR IS
BEGIN
    P2.EXTEND;
    P2(P2.LAST) := 'PLUS';
    P3 := INTERVAL '1' YEAR;
    RETURN P2;
END;
/

CREATE OR REPLACE FUNCTION FUNC_5_SIMPLE_PARAMS(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2) RETURN VARCHAR2 IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_5_COMPLEX_PARAMS(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB) RETURN TYPES.PLSQL_ATAB IS
BEGIN
    RETURN P4;
END;
/

CREATE OR REPLACE FUNCTION FUNC_5_SIMPLE_D_PARAMS(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2) RETURN VARCHAR2 IS
BEGIN
    P1 := P1 || 'PLUS';
    P2 := 'PLUS';
    P4 := P4 || 'PLUS';
    P5 := 'PLUS';
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_5_COMPLEX_D_PARAMS(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB) RETURN BLOB IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
    P2 := SQL_VARR('FIRST', 'SECOND', 'THIRD');
    P4(1) := '1';
    P4(2) := '2';
    DBMS_LOB.APPEND(P5, TO_BLOB('0123'));    
    RETURN P5;
END;
/

CREATE OR REPLACE FUNCTION FUNC_10_SIMPLE_PARAMS(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2,
                                                 P6 IN VARCHAR2, P7 IN VARCHAR2, P8 IN VARCHAR2, P9 IN VARCHAR2, P10 IN VARCHAR2) RETURN VARCHAR2 IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_10_COMPLEX_PARAMS(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB,
                                                  P6 IN TIMESTAMP, P7 IN SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 IN TYPES.PLSQL_ATAB, P10 IN BLOB) RETURN TIMESTAMP IS
BEGIN
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_10_SIMPLE_D_PARAMS(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2,
                                                   P6 IN OUT VARCHAR2, P7 OUT VARCHAR2, P8 IN VARCHAR2, P9 IN OUT VARCHAR2, P10 OUT VARCHAR2) RETURN VARCHAR2 IS
BEGIN
    P1 := P1 || 'PLUS';
    P2 := 'PLUS';
    P4 := P4 || 'PLUS';
    P5 := 'PLUS';
    P6 := P6 || 'PLUS';
    P7 := 'PLUS';
    P9 := P9 || 'PLUS';
    P10 := 'PLUS';
    RETURN P1;
END;
/

CREATE OR REPLACE FUNCTION FUNC_10_COMPLEX_D_PARAMS(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB,
                                                    P6 IN OUT TIMESTAMP, P7 OUT SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 OUT TYPES.PLSQL_ATAB, P10 IN OUT BLOB) RETURN SQL_VARR IS
BEGIN
    P1 := P1 AT TIME ZONE 'US/Pacific';
    P2 := SQL_VARR('FIRST', 'SECOND', 'THIRD');
    P4(1) := '1';
    P4(2) := '2';
    DBMS_LOB.APPEND(P5, TO_BLOB('0123'));    
    P6 := P6 AT TIME ZONE 'US/Pacific';
    P7 := SQL_VARR('FIRST', 'SECOND', 'THIRD');
    P9(1) := '1';
    P9(2) := '2';
    DBMS_LOB.APPEND(P10, TO_BLOB('0123'));    
    RETURN P2;
END;
/

--------------------------------------------------------------------------------
-- PACKAGED OPERATIONS WITHOUT OVERLOADED NAMES
--------------------------------------------------------------------------------

CREATE OR REPLACE PACKAGE PACKAGED_OPS IS

    PROCEDURE PROC_3_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2);
    
    PROCEDURE PROC_3_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH);
    
    PROCEDURE PROC_3_SIMPLE_D_PARAMS_P(P1 IN VARCHAR2, P2 IN OUT VARCHAR2, P3 OUT VARCHAR2);
    
    PROCEDURE PROC_3_COMPLEX_D_PARAMS_P(P1 IN TIMESTAMP, P2 IN OUT SQL_VARR, P3 OUT INTERVAL YEAR TO MONTH);
    
    PROCEDURE PROC_5_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2);
    
    PROCEDURE PROC_5_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB);
    
    PROCEDURE PROC_5_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2);
    
    PROCEDURE PROC_5_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB);
    
    PROCEDURE PROC_10_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2,
                                                     P6 IN VARCHAR2, P7 IN VARCHAR2, P8 IN VARCHAR2, P9 IN VARCHAR2, P10 IN VARCHAR2);
    
    PROCEDURE PROC_10_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB,
                                                      P6 IN TIMESTAMP, P7 IN SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 IN TYPES.PLSQL_ATAB, P10 IN BLOB);
    
    PROCEDURE PROC_10_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2,
                                                       P6 IN OUT VARCHAR2, P7 OUT VARCHAR2, P8 IN VARCHAR2, P9 IN OUT VARCHAR2, P10 OUT VARCHAR2);
    
    PROCEDURE PROC_10_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB,
                                                        P6 IN OUT TIMESTAMP, P7 OUT SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 OUT TYPES.PLSQL_ATAB, P10 IN OUT BLOB);
    
    FUNCTION FUNC_3_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION FUNC_3_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH) RETURN TIMESTAMP;
    
    FUNCTION FUNC_3_SIMPLE_D_PARAMS_P(P1 IN VARCHAR2, P2 IN OUT VARCHAR2, P3 OUT VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION FUNC_3_COMPLEX_D_PARAMS_P(P1 IN TIMESTAMP, P2 IN OUT SQL_VARR, P3 OUT INTERVAL YEAR TO MONTH) RETURN SQL_VARR;
    
    FUNCTION FUNC_5_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION FUNC_5_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB) RETURN TYPES.PLSQL_ATAB;
    
    FUNCTION FUNC_5_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION FUNC_5_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB) RETURN BLOB;
    
    FUNCTION FUNC_10_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2,
                                                     P6 IN VARCHAR2, P7 IN VARCHAR2, P8 IN VARCHAR2, P9 IN VARCHAR2, P10 IN VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION FUNC_10_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB,
                                                      P6 IN TIMESTAMP, P7 IN SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 IN TYPES.PLSQL_ATAB, P10 IN BLOB) RETURN TIMESTAMP;
    
    FUNCTION FUNC_10_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2,
                                                       P6 IN OUT VARCHAR2, P7 OUT VARCHAR2, P8 IN VARCHAR2, P9 IN OUT VARCHAR2, P10 OUT VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION FUNC_10_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB,
                                                        P6 IN OUT TIMESTAMP, P7 OUT SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 OUT TYPES.PLSQL_ATAB, P10 IN OUT BLOB) RETURN SQL_VARR;

END;
/

CREATE OR REPLACE PACKAGE BODY PACKAGED_OPS IS

    PROCEDURE PROC_3_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2) IS
    BEGIN
        PROC_3_SIMPLE_PARAMS(P1, P2, P3);
    END;
    
    PROCEDURE PROC_3_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH) IS
    BEGIN
        PROC_3_COMPLEX_PARAMS(P1, P2, P3);
    END;
    
    PROCEDURE PROC_3_SIMPLE_D_PARAMS_P(P1 IN VARCHAR2, P2 IN OUT VARCHAR2, P3 OUT VARCHAR2) IS
    BEGIN
        PROC_3_SIMPLE_D_PARAMS(P1, P2, P3);
    END;
    
    PROCEDURE PROC_3_COMPLEX_D_PARAMS_P(P1 IN TIMESTAMP, P2 IN OUT SQL_VARR, P3 OUT INTERVAL YEAR TO MONTH) IS
    BEGIN
        PROC_3_COMPLEX_D_PARAMS(P1, P2, P3);
    END;
    
    PROCEDURE PROC_5_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2) IS
    BEGIN
        PROC_5_SIMPLE_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    PROCEDURE PROC_5_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB) IS
    BEGIN
        PROC_5_COMPLEX_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    PROCEDURE PROC_5_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2) IS
    BEGIN
        PROC_5_SIMPLE_D_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    PROCEDURE PROC_5_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB) IS
    BEGIN
        PROC_5_COMPLEX_D_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    PROCEDURE PROC_10_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2,
                                                     P6 IN VARCHAR2, P7 IN VARCHAR2, P8 IN VARCHAR2, P9 IN VARCHAR2, P10 IN VARCHAR2) IS
    BEGIN
        PROC_10_SIMPLE_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;
    
    PROCEDURE PROC_10_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB,
                                                      P6 IN TIMESTAMP, P7 IN SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 IN TYPES.PLSQL_ATAB, P10 IN BLOB) IS
    BEGIN
        PROC_10_COMPLEX_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;
    
    PROCEDURE PROC_10_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2,
                                                       P6 IN OUT VARCHAR2, P7 OUT VARCHAR2, P8 IN VARCHAR2, P9 IN OUT VARCHAR2, P10 OUT VARCHAR2) IS
    BEGIN
        PROC_10_SIMPLE_D_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;
    
    PROCEDURE PROC_10_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB,
                                                        P6 IN OUT TIMESTAMP, P7 OUT SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 OUT TYPES.PLSQL_ATAB, P10 IN OUT BLOB) IS
    BEGIN
        PROC_10_COMPLEX_D_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;
    
    FUNCTION FUNC_3_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_3_SIMPLE_PARAMS(P1, P2, P3);
    END;
    
    FUNCTION FUNC_3_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH) RETURN TIMESTAMP IS
    BEGIN
        RETURN FUNC_3_COMPLEX_PARAMS(P1, P2, P3);
    END;
    
    FUNCTION FUNC_3_SIMPLE_D_PARAMS_P(P1 IN VARCHAR2, P2 IN OUT VARCHAR2, P3 OUT VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_3_SIMPLE_D_PARAMS(P1, P2, P3);
    END;
    
    FUNCTION FUNC_3_COMPLEX_D_PARAMS_P(P1 IN TIMESTAMP, P2 IN OUT SQL_VARR, P3 OUT INTERVAL YEAR TO MONTH) RETURN SQL_VARR IS
    BEGIN
        RETURN FUNC_3_COMPLEX_D_PARAMS(P1, P2, P3);
    END;
    
    FUNCTION FUNC_5_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_5_SIMPLE_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    FUNCTION FUNC_5_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB) RETURN TYPES.PLSQL_ATAB IS
    BEGIN
        RETURN FUNC_5_COMPLEX_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    FUNCTION FUNC_5_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_5_SIMPLE_D_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    FUNCTION FUNC_5_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB) RETURN BLOB IS
    BEGIN
        RETURN FUNC_5_COMPLEX_D_PARAMS(P1, P2, P3, P4, P5);
    END;
    
    FUNCTION FUNC_10_SIMPLE_PARAMS_P(P1 IN VARCHAR2, P2 IN VARCHAR2, P3 IN VARCHAR2, P4 IN VARCHAR2, P5 IN VARCHAR2,
                                                     P6 IN VARCHAR2, P7 IN VARCHAR2, P8 IN VARCHAR2, P9 IN VARCHAR2, P10 IN VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_10_SIMPLE_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;
    
    FUNCTION FUNC_10_COMPLEX_PARAMS_P(P1 IN TIMESTAMP, P2 IN SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 IN TYPES.PLSQL_ATAB, P5 IN BLOB,
                                                      P6 IN TIMESTAMP, P7 IN SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 IN TYPES.PLSQL_ATAB, P10 IN BLOB) RETURN TIMESTAMP IS
    BEGIN
        RETURN FUNC_10_COMPLEX_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;
    
    FUNCTION FUNC_10_SIMPLE_D_PARAMS_P(P1 IN OUT VARCHAR2, P2 OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2, P5 OUT VARCHAR2,
                                                       P6 IN OUT VARCHAR2, P7 OUT VARCHAR2, P8 IN VARCHAR2, P9 IN OUT VARCHAR2, P10 OUT VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_10_SIMPLE_D_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;
    
    FUNCTION FUNC_10_COMPLEX_D_PARAMS_P(P1 IN OUT TIMESTAMP, P2 OUT SQL_VARR, P3 IN INTERVAL YEAR TO MONTH, P4 OUT TYPES.PLSQL_ATAB, P5 IN OUT BLOB,
                                                        P6 IN OUT TIMESTAMP, P7 OUT SQL_VARR, P8 IN INTERVAL YEAR TO MONTH, P9 OUT TYPES.PLSQL_ATAB, P10 IN OUT BLOB) RETURN SQL_VARR IS
    BEGIN
        RETURN FUNC_10_COMPLEX_D_PARAMS(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    END;

END;
/

--------------------------------------------------------------------------------
-- PACKAGED OPERATIONS UTILIZING OVERLOADS
--------------------------------------------------------------------------------

CREATE OR REPLACE PACKAGE PACKAGED_OVERLOADED_OPS IS

    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2);
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH);
    
    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_INOUT IN OUT VARCHAR2, P3_OUT OUT VARCHAR2);
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_INOUT IN OUT SQL_VARR, P3_OUT OUT INTERVAL YEAR TO MONTH);
    
    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2);
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB);
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2);
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB);
    
    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2,
                            P6_IN IN VARCHAR2, P7_IN IN VARCHAR2, P8_IN IN VARCHAR2, P9_IN IN VARCHAR2, P10_IN IN VARCHAR2);
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB,
                            P6_IN IN TIMESTAMP, P7_IN IN SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_IN IN TYPES.PLSQL_ATAB, P10_IN IN BLOB);
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2,
                            P6_INOUT IN OUT VARCHAR2, P7_OUT OUT VARCHAR2, P8_IN IN VARCHAR2, P9_INOUT IN OUT VARCHAR2, P10_OUT OUT VARCHAR2);
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB,
                            P6_INOUT IN OUT TIMESTAMP, P7_OUT OUT SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_OUT OUT TYPES.PLSQL_ATAB, P10_INOUT IN OUT BLOB);
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH) RETURN TIMESTAMP;
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_INOUT IN OUT VARCHAR2, P3_OUT OUT VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_INOUT IN OUT SQL_VARR, P3_OUT OUT INTERVAL YEAR TO MONTH) RETURN SQL_VARR;
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB) RETURN TYPES.PLSQL_ATAB;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB) RETURN BLOB;
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2,
                           P6_IN IN VARCHAR2, P7_IN IN VARCHAR2, P8_IN IN VARCHAR2, P9_IN IN VARCHAR2, P10_IN IN VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB,
                           P6_IN IN TIMESTAMP, P7_IN IN SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_IN IN TYPES.PLSQL_ATAB, P10_IN IN BLOB) RETURN TIMESTAMP;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2,
                           P6_INOUT IN OUT VARCHAR2, P7_OUT OUT VARCHAR2, P8_IN IN VARCHAR2, P9_INOUT IN OUT VARCHAR2, P10_OUT OUT VARCHAR2) RETURN VARCHAR2;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB,
                           P6_INOUT IN OUT TIMESTAMP, P7_OUT OUT SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_OUT OUT TYPES.PLSQL_ATAB, P10_INOUT IN OUT BLOB) RETURN SQL_VARR;

END;
/

CREATE OR REPLACE PACKAGE BODY PACKAGED_OVERLOADED_OPS IS

    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2) IS
    BEGIN
        PROC_3_SIMPLE_PARAMS(P1_IN, P2_IN, P3_IN);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH) IS
    BEGIN
        PROC_3_COMPLEX_PARAMS(P1_IN, P2_IN, P3_IN);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_INOUT IN OUT VARCHAR2, P3_OUT OUT VARCHAR2) IS
    BEGIN
        PROC_3_SIMPLE_D_PARAMS(P1_IN, P2_INOUT, P3_OUT);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_INOUT IN OUT SQL_VARR, P3_OUT OUT INTERVAL YEAR TO MONTH) IS
    BEGIN
        PROC_3_COMPLEX_D_PARAMS(P1_IN, P2_INOUT, P3_OUT);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2) IS
    BEGIN
        PROC_5_SIMPLE_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB) IS
    BEGIN
        PROC_5_COMPLEX_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2) IS
    BEGIN
        PROC_5_SIMPLE_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_INOUT, P5_OUT);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB) IS
    BEGIN
        PROC_5_COMPLEX_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_OUT, P5_INOUT);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2,
                            P6_IN IN VARCHAR2, P7_IN IN VARCHAR2, P8_IN IN VARCHAR2, P9_IN IN VARCHAR2, P10_IN IN VARCHAR2) IS
    BEGIN
        PROC_10_SIMPLE_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN, P6_IN, P7_IN, P8_IN, P9_IN, P10_IN);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB,
                            P6_IN IN TIMESTAMP, P7_IN IN SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_IN IN TYPES.PLSQL_ATAB, P10_IN IN BLOB) IS
    BEGIN
        PROC_10_COMPLEX_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN, P6_IN, P7_IN, P8_IN, P9_IN, P10_IN);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2,
                            P6_INOUT IN OUT VARCHAR2, P7_OUT OUT VARCHAR2, P8_IN IN VARCHAR2, P9_INOUT IN OUT VARCHAR2, P10_OUT OUT VARCHAR2) IS
    BEGIN
        PROC_10_SIMPLE_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_INOUT, P5_OUT, P6_INOUT, P7_OUT, P8_IN, P9_INOUT, P10_OUT);
    END;
    
    PROCEDURE OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB,
                            P6_INOUT IN OUT TIMESTAMP, P7_OUT OUT SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_OUT OUT TYPES.PLSQL_ATAB, P10_INOUT IN OUT BLOB) IS
    BEGIN
        PROC_10_COMPLEX_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_OUT, P5_INOUT, P6_INOUT, P7_OUT, P8_IN, P9_OUT, P10_INOUT);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_3_SIMPLE_PARAMS(P1_IN, P2_IN, P3_IN);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH) RETURN TIMESTAMP IS
    BEGIN
        RETURN FUNC_3_COMPLEX_PARAMS(P1_IN, P2_IN, P3_IN);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_INOUT IN OUT VARCHAR2, P3_OUT OUT VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_3_SIMPLE_D_PARAMS(P1_IN, P2_INOUT, P3_OUT);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_INOUT IN OUT SQL_VARR, P3_OUT OUT INTERVAL YEAR TO MONTH) RETURN SQL_VARR IS
    BEGIN
        RETURN FUNC_3_COMPLEX_D_PARAMS(P1_IN, P2_INOUT, P3_OUT);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_5_SIMPLE_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB) RETURN TYPES.PLSQL_ATAB IS
    BEGIN
        RETURN FUNC_5_COMPLEX_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN);
    END;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_5_SIMPLE_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_INOUT, P5_OUT);
    END;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB) RETURN BLOB IS
    BEGIN
        RETURN FUNC_5_COMPLEX_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_OUT, P5_INOUT);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN VARCHAR2, P2_IN IN VARCHAR2, P3_IN IN VARCHAR2, P4_IN IN VARCHAR2, P5_IN IN VARCHAR2,
                           P6_IN IN VARCHAR2, P7_IN IN VARCHAR2, P8_IN IN VARCHAR2, P9_IN IN VARCHAR2, P10_IN IN VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_10_SIMPLE_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN, P6_IN, P7_IN, P8_IN, P9_IN, P10_IN);
    END;
    
    FUNCTION OVERLOADED_OP(P1_IN IN TIMESTAMP, P2_IN IN SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_IN IN TYPES.PLSQL_ATAB, P5_IN IN BLOB,
                           P6_IN IN TIMESTAMP, P7_IN IN SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_IN IN TYPES.PLSQL_ATAB, P10_IN IN BLOB) RETURN TIMESTAMP IS
    BEGIN
        RETURN FUNC_10_COMPLEX_PARAMS(P1_IN, P2_IN, P3_IN, P4_IN, P5_IN, P6_IN, P7_IN, P8_IN, P9_IN, P10_IN);
    END;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT VARCHAR2, P2_OUT OUT VARCHAR2, P3_IN IN VARCHAR2, P4_INOUT IN OUT VARCHAR2, P5_OUT OUT VARCHAR2,
                           P6_INOUT IN OUT VARCHAR2, P7_OUT OUT VARCHAR2, P8_IN IN VARCHAR2, P9_INOUT IN OUT VARCHAR2, P10_OUT OUT VARCHAR2) RETURN VARCHAR2 IS
    BEGIN
        RETURN FUNC_10_SIMPLE_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_INOUT, P5_OUT, P6_INOUT, P7_OUT, P8_IN, P9_INOUT, P10_OUT);
    END;
    
    FUNCTION OVERLOADED_OP(P1_INOUT IN OUT TIMESTAMP, P2_OUT OUT SQL_VARR, P3_IN IN INTERVAL YEAR TO MONTH, P4_OUT OUT TYPES.PLSQL_ATAB, P5_INOUT IN OUT BLOB,
                           P6_INOUT IN OUT TIMESTAMP, P7_OUT OUT SQL_VARR, P8_IN IN INTERVAL YEAR TO MONTH, P9_OUT OUT TYPES.PLSQL_ATAB, P10_INOUT IN OUT BLOB) RETURN SQL_VARR IS
    BEGIN
        RETURN FUNC_10_COMPLEX_D_PARAMS(P1_INOUT, P2_OUT, P3_IN, P4_OUT, P5_INOUT, P6_INOUT, P7_OUT, P8_IN, P9_OUT, P10_INOUT);
    END;

END;
/

--------------------------------------------------------------------------------
-- OPERATIONS THROWING EXCEPTIONS
--------------------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE PREDEF_EXCEPTION_PROC IS
BEGIN
    RAISE INVALID_NUMBER;
END;
/

CREATE OR REPLACE FUNCTION PREDEF_EXCEPTION_FUNC RETURN VARCHAR2 IS
BEGIN
    RAISE INVALID_NUMBER;
    RETURN 'DUMMY';
END;
/

CREATE OR REPLACE PROCEDURE USERDEF_EXCEPTION_PROC IS
    USERDEF_EXCEPTION EXCEPTION;
BEGIN
    RAISE USERDEF_EXCEPTION;
END;
/

CREATE OR REPLACE FUNCTION USERDEF_EXCEPTION_FUNC RETURN VARCHAR2 IS
    USERDEF_EXCEPTION EXCEPTION;
BEGIN
    RAISE USERDEF_EXCEPTION;
    RETURN 'DUMMY';
END;
/

CREATE OR REPLACE PROCEDURE APPERR_EXCEPTION_PROC IS
BEGIN
    RAISE_APPLICATION_ERROR(-20001, 'APPLICATION ERROR');
END;
/

CREATE OR REPLACE FUNCTION APPERR_EXCEPTION_FUNC RETURN VARCHAR2 IS
BEGIN
    RAISE_APPLICATION_ERROR(-20001, 'APPLICATION ERROR');
    RETURN 'DUMMY';
END;
/

CREATE OR REPLACE PACKAGE EXCEPTION_OPS IS

    PROCEDURE PREDEF_EXCEPTION_PROC_PKG;
    
    FUNCTION PREDEF_EXCEPTION_FUNC_PKG RETURN VARCHAR2;
    
    PROCEDURE USERDEF_EXCEPTION_PROC_PKG;
    
    FUNCTION USERDEF_EXCEPTION_FUNC_PKG RETURN VARCHAR2;
    
    PROCEDURE APPERR_EXCEPTION_PROC_PKG;
    
    FUNCTION APPERR_EXCEPTION_FUNC_PKG RETURN VARCHAR2;

END;
/

CREATE OR REPLACE PACKAGE BODY EXCEPTION_OPS IS

    PROCEDURE PREDEF_EXCEPTION_PROC_PKG IS
    BEGIN
        PREDEF_EXCEPTION_PROC;
    END;
    
    FUNCTION PREDEF_EXCEPTION_FUNC_PKG RETURN VARCHAR2 IS
    BEGIN
        RETURN PREDEF_EXCEPTION_FUNC;
    END;
    
    PROCEDURE USERDEF_EXCEPTION_PROC_PKG IS
    BEGIN
        USERDEF_EXCEPTION_PROC;
    END;
    
    FUNCTION USERDEF_EXCEPTION_FUNC_PKG RETURN VARCHAR2 IS
    BEGIN
        RETURN USERDEF_EXCEPTION_FUNC;
    END;
    
    PROCEDURE APPERR_EXCEPTION_PROC_PKG IS
    BEGIN
        APPERR_EXCEPTION_PROC;
    END;
    
    FUNCTION APPERR_EXCEPTION_FUNC_PKG RETURN VARCHAR2 IS
    BEGIN
        RETURN APPERR_EXCEPTION_FUNC;
    END;

END;
/

--------------------------------------------------------------------------------
-- OPERATIONS FOR TESTING LOOKUPS
--------------------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE PROC_TWO_VARCHAR2_PARAMS(P1 IN VARCHAR2, P2 IN OUT VARCHAR2) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_NUMBER_PARAMS(P1 IN NUMBER, P2 IN OUT NUMBER) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_SQLNTAB_PARAMS(P1 IN SQL_NTAB, P2 IN OUT SQL_NTAB) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_SQL_VARR_PARAMS(P1 IN SQL_VARR, P2 IN OUT SQL_VARR) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_SQL_OBJ_PARAMS(P1 IN SQL_OBJ, P2 IN OUT SQL_OBJ) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_PLSQL_NTAB_PARAMS(P1 IN TYPES.PLSQL_NTAB, P2 IN OUT TYPES.PLSQL_NTAB) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PLSQL_VARR_PARAMS(P1 IN TYPES.PLSQL_VARR, P2 IN OUT TYPES.PLSQL_VARR) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_PLSQL_ATAB_PARAMS(P1 IN TYPES.PLSQL_ATAB, P2 IN OUT TYPES.PLSQL_ATAB) IS
BEGIN
    NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_PLSQL_REC_PARAMS(P1 IN TYPES.PLSQL_REC, P2 IN OUT TYPES.PLSQL_REC) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_BOOLEAN_PARAMS(P1 IN BOOLEAN, P2 IN OUT BOOLEAN) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_CLOB_PARAMS(P1 IN CLOB, P2 IN OUT CLOB) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_DATE_PARAMS(P1 IN DATE, P2 IN OUT DATE) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_BLOB_PARAMS(P1 IN BLOB, P2 IN OUT BLOB) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_NVARCHAR2_PARAMS(P1 IN NVARCHAR2, P2 IN OUT NVARCHAR2) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_BINARY_INTEGER_PARAMS(P1 IN BINARY_INTEGER, P2 IN OUT BINARY_INTEGER) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_RAW_PARAMS(P1 IN RAW, P2 IN OUT RAW) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_FLOAT_PARAMS(P1 IN FLOAT, P2 IN OUT FLOAT) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_BINARY_DOUBLE_PARAMS(P1 IN BINARY_DOUBLE, P2 IN OUT BINARY_DOUBLE) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_BINARY_FLOAT_PARAMS(P1 IN BINARY_FLOAT, P2 IN OUT BINARY_FLOAT) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_CHAR_PARAMS(P1 IN CHAR, P2 IN OUT CHAR) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_INTERVALDS_PARAMS(P1 IN INTERVAL DAY TO SECOND, P2 IN OUT INTERVAL DAY TO SECOND) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_INTERVALYM_PARAMS(P1 IN INTERVAL YEAR TO MONTH, P2 IN OUT INTERVAL YEAR TO MONTH) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_ROWID_PARAMS(P1 IN ROWID, P2 IN OUT ROWID) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_TIMESTAMP_PARAMS(P1 IN TIMESTAMP, P2 IN OUT TIMESTAMP) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_TIMESTAMPLTZ_PARAMS(P1 IN TIMESTAMP WITH LOCAL TIME ZONE, P2 IN OUT TIMESTAMP WITH LOCAL TIME ZONE) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_TIMESTAMPTZ_PARAMS(P1 IN TIMESTAMP WITH TIME ZONE, P2 IN OUT TIMESTAMP WITH TIME ZONE) IS
BEGIN
    P2 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_FOUR_VARCHAR2_PARAMS(P1 IN VARCHAR2, P2 IN OUT VARCHAR2, P3 IN VARCHAR2, P4 IN OUT VARCHAR2) IS
BEGIN
    P2 := NULL;
    P4 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_FOUR_NUMBER_PARAMS(P1 IN NUMBER, P2 IN OUT NUMBER, P3 IN NUMBER, P4 IN OUT NUMBER) IS
BEGIN
    P2 := NULL;
    P4 := NULL;
END;
/

CREATE OR REPLACE PROCEDURE PROC_TWO_MIXED_PARAMS(P1 IN VARCHAR2, P2 IN OUT NUMBER) IS
BEGIN
    P2 := NULL;
END;
/

--------------------------------------------------------------------------------
-- TIDY UP OPERATIONS
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Operations to remove and check for temporary tables (whose names begin TEMP)

CREATE OR REPLACE PROCEDURE REMOVE_TEMP_TABLES IS
BEGIN
    FOR T IN (
        SELECT 
            OBJECT_NAME 
        FROM 
            USER_OBJECTS 
        WHERE 
            OBJECT_TYPE = 'TABLE' AND 
            OBJECT_NAME LIKE 'TEMP%')
    LOOP
        EXECUTE IMMEDIATE 'DROP TABLE ' || T.OBJECT_NAME || ' CASCADE CONSTRAINTS';
    END LOOP;
END;
/

CREATE OR REPLACE FUNCTION TEMP_TABLES_EXIST RETURN NUMBER IS
    NUMROWS NUMBER;
BEGIN
    SELECT 
        COUNT(*) INTO NUMROWS
    FROM 
        USER_OBJECTS 
    WHERE 
        OBJECT_TYPE = 'TABLE' AND 
        OBJECT_NAME LIKE 'TEMP%';
    IF NUMROWS <> 0
    THEN
        RETURN 1;
    ELSE
        RETURN 0;
    END IF;
END;
/

--------------------------------------------------------------------------------
-- TABLES USING SIMPLE TYPES
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- MASTER and DETAIL are the tables which are modified by the test operations

CREATE TABLE MASTER (
    MASTER_ID INTEGER PRIMARY KEY,
    MC1 VARCHAR2(32),
    MC2 TIMESTAMP,
    MC3 NUMBER,
    MC4 FLOAT
);

CREATE TABLE DETAIL (
    DETAIL_ID INTEGER PRIMARY KEY,
    MASTER_ID INTEGER REFERENCES MASTER (MASTER_ID) ON DELETE CASCADE,
    DC1 VARCHAR2(32),
    DC2 INTEGER,
    DC3 INTERVAL YEAR TO MONTH
);

--------------------------------------------------------------------------------
-- Immutable tables containing data used to populate MASTER and DETAIL

CREATE TABLE DATA_MASTER_ORIGINAL 
AS 
    SELECT * FROM MASTER;
    
CREATE TABLE DATA_DETAIL_ORIGINAL 
AS 
    SELECT * FROM DETAIL;
    
CREATE TABLE DATA_MASTER_ADD_M 
AS 
    SELECT * FROM MASTER;
    
CREATE TABLE DATA_DETAIL_ADD_D 
AS 
    SELECT * FROM DETAIL;
    
CREATE TABLE DATA_MASTER_ADD_M_D 
AS 
    SELECT * FROM MASTER;
    
CREATE TABLE DATA_DETAIL_ADD_M_D 
AS 
    SELECT * FROM DETAIL;
    
CREATE TABLE DATA_MASTER_CHG_M 
AS 
    SELECT * FROM MASTER;
    
CREATE TABLE DATA_DETAIL_CHG_D 
AS 
    SELECT * FROM DETAIL;
    
CREATE TABLE DATA_MASTER_CHG_M_D 
AS 
    SELECT * FROM MASTER;
    
CREATE TABLE DATA_DETAIL_CHG_M_D 
AS 
    SELECT * FROM DETAIL;
    
CREATE TABLE DATA_DETAIL_DEL_D (
    DETAIL_ID INTEGER
);

CREATE TABLE DATA_MASTER_DEL_M_D (
    MASTER_ID INTEGER
);

--------------------------------------------------------------------------------
-- Data used to setup MASTER and DETAIL

BEGIN
    FOR M IN 1..20
    LOOP
        INSERT INTO DATA_MASTER_ORIGINAL (MASTER_ID, MC1, MC2, MC3, MC4) 
        VALUES(
            M, 
            'CHARDATA' || M, 
            SYSTIMESTAMP, 
            M,
            M
        );
        
        FOR D IN 1..16
        LOOP
            INSERT INTO DATA_DETAIL_ORIGINAL (DETAIL_ID, MASTER_ID, DC1, DC2, DC3) 
            VALUES(
                100*M + D, 
                M,
                'CHARDATA' || M || '-' || D, 
                D,
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Data added to MASTER by the operation ADD_MASTER

BEGIN
    FOR M IN 101..108
    LOOP
        INSERT INTO DATA_MASTER_ADD_M (MASTER_ID, MC1, MC2, MC3, MC4) 
        VALUES(
            M, 
            'CHARDATA' || M, 
            SYSTIMESTAMP, 
            M,
            M
        );
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Data added to DETAIL by the operation ADD_DETAIL

BEGIN
    FOR M IN 1..4
    LOOP
        FOR D IN 51..56
        LOOP
            INSERT INTO DATA_DETAIL_ADD_D (DETAIL_ID, MASTER_ID, DC1, DC2, DC3) 
            VALUES(
                100*M + D, 
                M,
                'CHARDATA' || M || '-' || D, 
                D,
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/    
COMMIT;
    
--------------------------------------------------------------------------------
-- Data added to MASTER and DETAIL by the operation ADD_MASTER_DETAIL

BEGIN
    FOR M IN 201..202
    LOOP
        INSERT INTO DATA_MASTER_ADD_M_D (MASTER_ID, MC1, MC2, MC3, MC4) 
        VALUES(
            M, 
            'CHARDATA' || M, 
            SYSTIMESTAMP, 
            M,
            M
        );
        
        FOR D IN 1..8
        LOOP
            INSERT INTO DATA_DETAIL_ADD_M_D (DETAIL_ID, MASTER_ID, DC1, DC2, DC3) 
            VALUES(
                100*M + D, 
                M,
                'CHARDATA' || M || '-' || D, 
                D,
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/    
COMMIT;
    
--------------------------------------------------------------------------------
-- Data changed in MASTER by the operation CHANGE_MASTER

BEGIN
    FOR M IN 5..15
    LOOP
        INSERT INTO DATA_MASTER_CHG_M (MASTER_ID, MC1, MC2, MC3, MC4) 
        VALUES(
            M, 
            'CHANGED' || M, 
            SYSTIMESTAMP, 
            M,
            M
        );
    END LOOP;
END;
/
COMMIT;
    
--------------------------------------------------------------------------------
-- Data changed in DETAIL by the operation CHANGE_DETAIL

BEGIN
    FOR M IN 7..10
    LOOP
        FOR D IN 9..15
        LOOP
            INSERT INTO DATA_DETAIL_CHG_D (DETAIL_ID, MASTER_ID, DC1, DC2, DC3) 
            VALUES(
                100*M + D, 
                M,
                'CHANGED' || M || '-' || D, 
                D,
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;
    
--------------------------------------------------------------------------------
-- Data changed in MASTER and DETAIL by the operation CHANGE_MASTER_DETAIL

BEGIN
    FOR M IN 9..12
    LOOP
        INSERT INTO DATA_MASTER_CHG_M_D (MASTER_ID, MC1, MC2, MC3, MC4) 
        VALUES(
            M, 
            'CHANGED' || M, 
            SYSTIMESTAMP, 
            M,
            M
        );
        
        FOR D IN 7..9
        LOOP
            INSERT INTO DATA_DETAIL_CHG_M_D (DETAIL_ID, MASTER_ID, DC1, DC2, DC3) 
            VALUES(
                100*M + D, 
                M,
                'CHANGED' || M || '-' || D, 
                D,
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;
    
--------------------------------------------------------------------------------
-- Data deleted in DETAIL by the operation DELETE_DETAIL

BEGIN
    FOR M IN 4..8
    LOOP
        FOR D IN 6..9
        LOOP
            INSERT INTO DATA_DETAIL_DEL_D (DETAIL_ID) 
            VALUES(
                100*M + D
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Data deleted in MASTER and DETAIL by the operation DELETE_MASTER_DETAIL

BEGIN
    FOR M IN 10..14
    LOOP
        INSERT INTO DATA_MASTER_DEL_M_D (MASTER_ID) 
        VALUES(
            M
        );
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Views containing expected contents of MASTER and DETAIL after each operation

CREATE OR REPLACE VIEW RESULT_MASTER_ADD_M 
AS 
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL
    UNION ALL
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ADD_M;

CREATE OR REPLACE VIEW RESULT_DETAIL_ADD_M
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL;
    
CREATE OR REPLACE VIEW RESULT_MASTER_ADD_D
AS 
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL;

CREATE OR REPLACE VIEW RESULT_DETAIL_ADD_D
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL
    UNION ALL
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ADD_D;
    
CREATE OR REPLACE VIEW RESULT_MASTER_ADD_M_D
AS 
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL
    UNION ALL
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ADD_M_D;

CREATE OR REPLACE VIEW RESULT_DETAIL_ADD_M_D
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL
    UNION ALL
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ADD_M_D;
    
CREATE OR REPLACE VIEW RESULT_MASTER_CHG_M
AS 
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL 
        WHERE MASTER_ID NOT IN (SELECT MASTER_ID FROM DATA_MASTER_CHG_M)
    UNION ALL
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_CHG_M;
    
CREATE OR REPLACE VIEW RESULT_DETAIL_CHG_M
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL;

CREATE OR REPLACE VIEW RESULT_MASTER_CHG_D
AS 
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL;

CREATE OR REPLACE VIEW RESULT_DETAIL_CHG_D
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL
        WHERE DETAIL_ID NOT IN (SELECT DETAIL_ID FROM DATA_DETAIL_CHG_D)
    UNION ALL
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_CHG_D;

CREATE OR REPLACE VIEW RESULT_MASTER_CHG_M_D
AS
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL 
        WHERE MASTER_ID NOT IN (SELECT MASTER_ID FROM DATA_MASTER_CHG_M_D)
    UNION ALL
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_CHG_M_D;

CREATE OR REPLACE VIEW RESULT_DETAIL_CHG_M_D
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL
        WHERE DETAIL_ID NOT IN (SELECT DETAIL_ID FROM DATA_DETAIL_CHG_M_D)
    UNION ALL
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_CHG_M_D;

CREATE OR REPLACE VIEW RESULT_MASTER_DEL_D
AS
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL; 

CREATE OR REPLACE VIEW RESULT_DETAIL_DEL_D
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL
        WHERE DETAIL_ID NOT IN (SELECT DETAIL_ID FROM DATA_DETAIL_DEL_D);

CREATE OR REPLACE VIEW RESULT_MASTER_DEL_M_D
AS
    SELECT MASTER_ID,MC1,MC2,MC3,MC4 FROM DATA_MASTER_ORIGINAL 
        WHERE MASTER_ID NOT IN (SELECT MASTER_ID FROM DATA_MASTER_DEL_M_D);

CREATE OR REPLACE VIEW RESULT_DETAIL_DEL_M_D
AS
    SELECT DETAIL_ID,MASTER_ID,DC1,DC2,DC3 FROM DATA_DETAIL_ORIGINAL
        WHERE MASTER_ID NOT IN (SELECT MASTER_ID FROM DATA_MASTER_DEL_M_D);

--------------------------------------------------------------------------------
-- Operation to setup the original data in MASTER and DETAIL

CREATE OR REPLACE PROCEDURE SETUP_TABLE_DATA IS
BEGIN
    DELETE FROM DETAIL;
    DELETE FROM MASTER;
    INSERT INTO MASTER SELECT * FROM DATA_MASTER_ORIGINAL;
    INSERT INTO DETAIL SELECT * FROM DATA_DETAIL_ORIGINAL;
END;
/

--------------------------------------------------------------------------------
-- TEST OPERATIONS USING TABLES
--------------------------------------------------------------------------------

-- NOTE that comments indicate which view gives the expected final state of
-- the MASTER and DETAIL tables
CREATE OR REPLACE PACKAGE TABLE_DATA_OPS IS
    PROCEDURE ADD_MASTER; -- RESULT_MASTER_ADD_M, RESULT_DETAIL_ADD_M
    PROCEDURE ADD_DETAIL; -- RESULT_MASTER_ADD_D, RESULT_DETAIL_ADD_D
    PROCEDURE ADD_MASTER_DETAIL; -- RESULT_MASTER_ADD_M_D, RESULT_DETAIL_ADD_M_D
    PROCEDURE CHANGE_MASTER; -- RESULT_MASTER_CHG_M, RESULT_DETAIL_CHG_M
    PROCEDURE CHANGE_DETAIL; -- RESULT_MASTER_CHG_D, RESULT_DETAIL_CHG_D
    PROCEDURE CHANGE_MASTER_DETAIL; -- RESULT_MASTER_CHG_M_D, RESULT_DETAIL_CHG_M_D
    PROCEDURE DELETE_DETAIL; -- RESULT_MASTER_DEL_D, RESULT_DETAIL_DEL_D
    PROCEDURE DELETE_MASTER_DETAIL; -- RESULT_MASTER_DEL_M_D, RESULT_DETAIL_DEL_M_D
END;
/

CREATE OR REPLACE PACKAGE BODY TABLE_DATA_OPS IS
    PROCEDURE ADD_MASTER IS
    BEGIN
        INSERT INTO MASTER SELECT * FROM DATA_MASTER_ADD_M;
    END;
    
    PROCEDURE ADD_DETAIL IS
    BEGIN
        INSERT INTO DETAIL SELECT * FROM DATA_DETAIL_ADD_D;
    END;
    
    PROCEDURE ADD_MASTER_DETAIL IS
    BEGIN
        INSERT INTO MASTER SELECT * FROM DATA_MASTER_ADD_M_D;
        INSERT INTO DETAIL SELECT * FROM DATA_DETAIL_ADD_M_D;
    END;
    
    PROCEDURE CHANGE_MASTER IS
    BEGIN
        MERGE INTO MASTER DEST
            USING (SELECT * FROM DATA_MASTER_CHG_M) SRC
            ON (DEST.MASTER_ID = SRC.MASTER_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.MC1 = SRC.MC1,
                DEST.MC2 = SRC.MC2,
                DEST.MC3 = SRC.MC3,
                DEST.MC4 = SRC.MC4;
    END;
    
    PROCEDURE CHANGE_DETAIL IS
    BEGIN
        MERGE INTO DETAIL DEST
            USING (SELECT * FROM DATA_DETAIL_CHG_D) SRC
            ON (DEST.DETAIL_ID = SRC.DETAIL_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.DC1 = SRC.DC1,
                DEST.DC2 = SRC.DC2,
                DEST.DC3 = SRC.DC3;
    END;
    
    PROCEDURE CHANGE_MASTER_DETAIL IS
    BEGIN
        MERGE INTO MASTER DEST
            USING (SELECT * FROM DATA_MASTER_CHG_M_D) SRC
            ON (DEST.MASTER_ID = SRC.MASTER_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.MC1 = SRC.MC1,
                DEST.MC2 = SRC.MC2,
                DEST.MC3 = SRC.MC3,
                DEST.MC4 = SRC.MC4;
        MERGE INTO DETAIL DEST
            USING (SELECT * FROM DATA_DETAIL_CHG_M_D) SRC
            ON (DEST.DETAIL_ID = SRC.DETAIL_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.DC1 = SRC.DC1,
                DEST.DC2 = SRC.DC2,
                DEST.DC3 = SRC.DC3;
    END;
    
    PROCEDURE DELETE_DETAIL IS
    BEGIN
        DELETE FROM DETAIL
        WHERE
            DETAIL_ID IN (SELECT DETAIL_ID FROM DATA_DETAIL_DEL_D);
    END;
    
    PROCEDURE DELETE_MASTER_DETAIL IS
    BEGIN
        DELETE FROM MASTER
        WHERE
            MASTER_ID IN (SELECT MASTER_ID FROM DATA_MASTER_DEL_M_D);
    END;    
END;
/

--------------------------------------------------------------------------------
-- TABLE COMPARISON OPERATIONS
--------------------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE COMPARE_MASTER_TABLES(TABLE_A VARCHAR2, TABLE_B VARCHAR2)
IS
    TYPE RC_T IS REF CURSOR;
    RC RC_T;
    STMT VARCHAR2(1024);
    ROW_COUNT NUMBER;
BEGIN
    STMT := 
        'SELECT COUNT(*) FROM ( ( ' ||
	'    SELECT M.MASTER_ID, M.MC1, M.MC2, M.MC3, M.MC4 FROM ' || TABLE_A || ' M ' ||
        '    MINUS ' ||
	'    SELECT M.MASTER_ID, M.MC1, M.MC2, M.MC3, M.MC4 FROM ' || TABLE_B || ' M ' ||
        ') UNION ALL ( ' ||
	'    SELECT M.MASTER_ID, M.MC1, M.MC2, M.MC3, M.MC4 FROM ' || TABLE_B || ' M ' ||
        '    MINUS ' ||
	'    SELECT M.MASTER_ID, M.MC1, M.MC2, M.MC3, M.MC4 FROM ' || TABLE_A || ' M ' ||
        ') )';
    OPEN RC FOR STMT;
    FETCH RC INTO ROW_COUNT;
    CLOSE RC;
    IF ROW_COUNT <> 0
    THEN
        RAISE_APPLICATION_ERROR(-20001, 'MASTER TABLES DIFFER: ' || TABLE_A || ' AND ' || TABLE_B);
    END IF;
END;
/

CREATE OR REPLACE PROCEDURE COMPARE_DETAIL_TABLES(TABLE_A VARCHAR2, TABLE_B VARCHAR2)
IS
    TYPE RC_T IS REF CURSOR;
    RC RC_T;
    STMT VARCHAR2(1024);
    ROW_COUNT NUMBER;
BEGIN
    STMT := 
        'SELECT COUNT(*) FROM ( ( ' ||
	'    SELECT D.DETAIL_ID, D.MASTER_ID, D.DC1, D.DC2, D.DC3 FROM ' || TABLE_A || ' D ' ||
        '    MINUS ' ||
	'    SELECT D.DETAIL_ID, D.MASTER_ID, D.DC1, D.DC2, D.DC3 FROM ' || TABLE_B || ' D ' ||
        ') UNION ALL ( ' ||
	'    SELECT D.DETAIL_ID, D.MASTER_ID, D.DC1, D.DC2, D.DC3 FROM ' || TABLE_B || ' D ' ||
        '    MINUS ' ||
	'    SELECT D.DETAIL_ID, D.MASTER_ID, D.DC1, D.DC2, D.DC3 FROM ' || TABLE_A || ' D ' ||
        ') )';
    OPEN RC FOR STMT;
    FETCH RC INTO ROW_COUNT;
    CLOSE RC;
    IF ROW_COUNT <> 0
    THEN
        RAISE_APPLICATION_ERROR(-20001, 'DETAIL TABLES DIFFER: ' || TABLE_A || ' AND ' || TABLE_B);
    END IF;
END;
/

--------------------------------------------------------------------------------
-- VERIFY THAT TEST OPERATIONS USING TABLES YIELD EXPECTED RESULTS
--------------------------------------------------------------------------------

BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.ADD_MASTER;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_ADD_M');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_ADD_M');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.ADD_DETAIL;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_ADD_D');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_ADD_D');
    COMMIT;
END;
/
            
BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.ADD_MASTER_DETAIL;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_ADD_M_D');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_ADD_M_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.CHANGE_MASTER;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_CHG_M');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_CHG_M');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.CHANGE_DETAIL;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_CHG_D');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_CHG_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.CHANGE_MASTER_DETAIL;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_CHG_M_D');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_CHG_M_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.DELETE_DETAIL;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_DEL_D');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_DEL_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLE_DATA;
    TABLE_DATA_OPS.DELETE_MASTER_DETAIL;
    COMPARE_MASTER_TABLES('MASTER', 'RESULT_MASTER_DEL_M_D');
    COMPARE_DETAIL_TABLES('DETAIL', 'RESULT_DETAIL_DEL_M_D');
    COMMIT;
END;
/

DELETE FROM MASTER;
COMMIT;

--------------------------------------------------------------------------------
-- TABLES USING COMPLEX TYPES
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- MASTERX and DETAILX are the tables which are modified by the test operations

CREATE TABLE MASTERX (
    MASTERX_ID INTEGER PRIMARY KEY,
    MXC1 VARCHAR2(32),
    MXC2 TIMESTAMP,
    MXC3 SQL_VARR,
    MXC4 SQL_OBJ    
);

CREATE TABLE DETAILX (
    DETAILX_ID INTEGER PRIMARY KEY,
    MASTERX_ID INTEGER REFERENCES MASTERX (MASTERX_ID) ON DELETE CASCADE,
    DXC1 VARCHAR2(32),
    DXC2 CLOB,
    DXC3 INTERVAL YEAR TO MONTH
);

--------------------------------------------------------------------------------
-- Immutable tables containing data used to populate MASTERX and DETAILX

CREATE TABLE DATA_MASTERX_ORIGINAL 
AS 
    SELECT * FROM MASTERX;
    
CREATE TABLE DATA_DETAILX_ORIGINAL 
AS 
    SELECT * FROM DETAILX;
    
CREATE TABLE DATA_MASTERX_ADD_M 
AS 
    SELECT * FROM MASTERX;
    
CREATE TABLE DATA_DETAILX_ADD_D 
AS 
    SELECT * FROM DETAILX;
    
CREATE TABLE DATA_MASTERX_ADD_M_D 
AS 
    SELECT * FROM MASTERX;
    
CREATE TABLE DATA_DETAILX_ADD_M_D 
AS 
    SELECT * FROM DETAILX;
    
CREATE TABLE DATA_MASTERX_CHG_M 
AS 
    SELECT * FROM MASTERX;
    
CREATE TABLE DATA_DETAILX_CHG_D 
AS 
    SELECT * FROM DETAILX;
    
CREATE TABLE DATA_MASTERX_CHG_M_D 
AS 
    SELECT * FROM MASTERX;
    
CREATE TABLE DATA_DETAILX_CHG_M_D 
AS 
    SELECT * FROM DETAILX;
    
CREATE TABLE DATA_DETAILX_DEL_D (
    DETAILX_ID INTEGER
);

CREATE TABLE DATA_MASTERX_DEL_M_D (
    MASTERX_ID INTEGER
);

--------------------------------------------------------------------------------
-- Data used to setup MASTERX and DETAILX

BEGIN
    FOR M IN 1..20
    LOOP
        INSERT INTO DATA_MASTERX_ORIGINAL (MASTERX_ID, MXC1, MXC2, MXC3, MXC4) 
        VALUES(
            M, 
            'CHARDATA' || M, 
            SYSTIMESTAMP, 
            SQL_VARR('A' || M, 'B' || M), 
            SQL_OBJ(M, 'A' || M)
        );
        
        FOR D IN 1..16
        LOOP
            INSERT INTO DATA_DETAILX_ORIGINAL (DETAILX_ID, MASTERX_ID, DXC1, DXC2, DXC3) 
            VALUES(
                100*M + D, 
                M,
                'CHARDATA' || M || '-' || D, 
                'CLOBDATA' || M || '-' || D, 
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Data added to MASTERX by the operation ADD_MASTERX

BEGIN
    FOR M IN 101..108
    LOOP
        INSERT INTO DATA_MASTERX_ADD_M (MASTERX_ID, MXC1, MXC2, MXC3, MXC4) 
        VALUES(
            M, 
            'CHARDATA' || M, 
            SYSTIMESTAMP, 
            SQL_VARR('A' || M, 'B' || M), 
            SQL_OBJ(M, 'A' || M)
        );
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Data added to DETAILX by the operation ADD_DETAILX

BEGIN
    FOR M IN 1..4
    LOOP
        FOR D IN 51..56
        LOOP
            INSERT INTO DATA_DETAILX_ADD_D (DETAILX_ID, MASTERX_ID, DXC1, DXC2, DXC3) 
            VALUES(
                100*M + D, 
                M,
                'CHARDATA' || M || '-' || D, 
                'CLOBDATA' || M || '-' || D, 
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/    
COMMIT;
    
--------------------------------------------------------------------------------
-- Data added to MASTERX and DETAILX by the operation ADD_MASTERX_DETAILX

BEGIN
    FOR M IN 201..202
    LOOP
        INSERT INTO DATA_MASTERX_ADD_M_D (MASTERX_ID, MXC1, MXC2, MXC3, MXC4) 
        VALUES(
            M, 
            'CHARDATA' || M, 
            SYSTIMESTAMP, 
            SQL_VARR('A' || M, 'B' || M), 
            SQL_OBJ(M, 'A' || M)
        );
        
        FOR D IN 1..8
        LOOP
            INSERT INTO DATA_DETAILX_ADD_M_D (DETAILX_ID, MASTERX_ID, DXC1, DXC2, DXC3) 
            VALUES(
                100*M + D, 
                M,
                'CHARDATA' || M || '-' || D, 
                'CLOBDATA' || M || '-' || D, 
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/    
COMMIT;
    
--------------------------------------------------------------------------------
-- Data changed in MASTERX by the operation CHANGE_MASTERX

BEGIN
    FOR M IN 5..15
    LOOP
        INSERT INTO DATA_MASTERX_CHG_M (MASTERX_ID, MXC1, MXC2, MXC3, MXC4) 
        VALUES(
            M, 
            'CHANGED' || M, 
            SYSTIMESTAMP, 
            SQL_VARR('A' || M, 'B' || M), 
            SQL_OBJ(M, 'A' || M)
        );
    END LOOP;
END;
/
COMMIT;
    
--------------------------------------------------------------------------------
-- Data changed in DETAILX by the operation CHANGE_DETAILX

BEGIN
    FOR M IN 7..10
    LOOP
        FOR D IN 9..15
        LOOP
            INSERT INTO DATA_DETAILX_CHG_D (DETAILX_ID, MASTERX_ID, DXC1, DXC2, DXC3) 
            VALUES(
                100*M + D, 
                M,
                'CHANGED' || M || '-' || D, 
                'CHANGED' || M || '-' || D, 
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;
    
--------------------------------------------------------------------------------
-- Data changed in MASTERX and DETAILX by the operation CHANGE_MASTERX_DETAILX

BEGIN
    FOR M IN 9..12
    LOOP
        INSERT INTO DATA_MASTERX_CHG_M_D (MASTERX_ID, MXC1, MXC2, MXC3, MXC4) 
        VALUES(
            M, 
            'CHANGED' || M, 
            SYSTIMESTAMP, 
            SQL_VARR('A' || M, 'B' || M), 
            SQL_OBJ(M, 'A' || M)
        );
        
        FOR D IN 7..9
        LOOP
            INSERT INTO DATA_DETAILX_CHG_M_D (DETAILX_ID, MASTERX_ID, DXC1, DXC2, DXC3) 
            VALUES(
                100*M + D, 
                M,
                'CHANGED' || M || '-' || D, 
                'CHANGED' || M || '-' || D, 
                INTERVAL '1' YEAR
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;
    
--------------------------------------------------------------------------------
-- Data deleted in DETAILX by the operation DELETE_DETAILX

BEGIN
    FOR M IN 4..8
    LOOP
        FOR D IN 6..9
        LOOP
            INSERT INTO DATA_DETAILX_DEL_D (DETAILX_ID) 
            VALUES(
                100*M + D
            );
        END LOOP;
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Data deleted in MASTERX and DETAILX by the operation DELETE_MASTERX_DETAILX

BEGIN
    FOR M IN 10..14
    LOOP
        INSERT INTO DATA_MASTERX_DEL_M_D (MASTERX_ID) 
        VALUES(
            M
        );
    END LOOP;
END;
/
COMMIT;

--------------------------------------------------------------------------------
-- Views containing expected contents of MASTERX and DETAILX after each operation

CREATE OR REPLACE VIEW RESULT_MASTERX_ADD_M 
AS 
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL
    UNION ALL
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ADD_M;

CREATE OR REPLACE VIEW RESULT_DETAILX_ADD_M
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL;
    
CREATE OR REPLACE VIEW RESULT_MASTERX_ADD_D
AS 
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL;

CREATE OR REPLACE VIEW RESULT_DETAILX_ADD_D
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL
    UNION ALL
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ADD_D;
    
CREATE OR REPLACE VIEW RESULT_MASTERX_ADD_M_D
AS 
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL
    UNION ALL
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ADD_M_D;

CREATE OR REPLACE VIEW RESULT_DETAILX_ADD_M_D
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL
    UNION ALL
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ADD_M_D;
    
CREATE OR REPLACE VIEW RESULT_MASTERX_CHG_M
AS 
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL 
        WHERE MASTERX_ID NOT IN (SELECT MASTERX_ID FROM DATA_MASTERX_CHG_M)
    UNION ALL
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_CHG_M;
    
CREATE OR REPLACE VIEW RESULT_DETAILX_CHG_M
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL;

CREATE OR REPLACE VIEW RESULT_MASTERX_CHG_D
AS 
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL;

CREATE OR REPLACE VIEW RESULT_DETAILX_CHG_D
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL
        WHERE DETAILX_ID NOT IN (SELECT DETAILX_ID FROM DATA_DETAILX_CHG_D)
    UNION ALL
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_CHG_D;

CREATE OR REPLACE VIEW RESULT_MASTERX_CHG_M_D
AS
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL 
        WHERE MASTERX_ID NOT IN (SELECT MASTERX_ID FROM DATA_MASTERX_CHG_M_D)
    UNION ALL
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_CHG_M_D;

CREATE OR REPLACE VIEW RESULT_DETAILX_CHG_M_D
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL
        WHERE DETAILX_ID NOT IN (SELECT DETAILX_ID FROM DATA_DETAILX_CHG_M_D)
    UNION ALL
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_CHG_M_D;

CREATE OR REPLACE VIEW RESULT_MASTERX_DEL_D
AS
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL; 

CREATE OR REPLACE VIEW RESULT_DETAILX_DEL_D
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL
        WHERE DETAILX_ID NOT IN (SELECT DETAILX_ID FROM DATA_DETAILX_DEL_D);

CREATE OR REPLACE VIEW RESULT_MASTERX_DEL_M_D
AS
    SELECT MASTERX_ID,MXC1,MXC2,MXC3,MXC4 FROM DATA_MASTERX_ORIGINAL 
        WHERE MASTERX_ID NOT IN (SELECT MASTERX_ID FROM DATA_MASTERX_DEL_M_D);

CREATE OR REPLACE VIEW RESULT_DETAILX_DEL_M_D
AS
    SELECT DETAILX_ID,MASTERX_ID,DXC1,DXC2,DXC3 FROM DATA_DETAILX_ORIGINAL
        WHERE MASTERX_ID NOT IN (SELECT MASTERX_ID FROM DATA_MASTERX_DEL_M_D);

--------------------------------------------------------------------------------
-- Operation to setup the original data in MASTERX and DETAILX

CREATE OR REPLACE PROCEDURE SETUP_TABLEX_DATA IS
BEGIN
    DELETE FROM DETAILX;
    DELETE FROM MASTERX;
    INSERT INTO MASTERX SELECT * FROM DATA_MASTERX_ORIGINAL;
    INSERT INTO DETAILX SELECT * FROM DATA_DETAILX_ORIGINAL;
END;
/

--------------------------------------------------------------------------------
-- TEST OPERATIONS USING TABLES WITH COMPLEX TYPES
--------------------------------------------------------------------------------

-- NOTE that comments indicate which view gives the expected final state of
-- the MASTERX and DETAILX tables
CREATE OR REPLACE PACKAGE TABLEX_DATA_OPS IS
    PROCEDURE ADD_MASTERX; -- RESULT_MASTERX_ADD_M, RESULT_DETAILX_ADD_M
    PROCEDURE ADD_DETAILX; -- RESULT_MASTERX_ADD_D, RESULT_DETAILX_ADD_D
    PROCEDURE ADD_MASTERX_DETAILX; -- RESULT_MASTERX_ADD_M_D, RESULT_DETAILX_ADD_M_D
    PROCEDURE CHANGE_MASTERX; -- RESULT_MASTERX_CHG_M, RESULT_DETAILX_CHG_M
    PROCEDURE CHANGE_DETAILX; -- RESULT_MASTERX_CHG_D, RESULT_DETAILX_CHG_D
    PROCEDURE CHANGE_MASTERX_DETAILX; -- RESULT_MASTERX_CHG_M_D, RESULT_DETAILX_CHG_M_D
    PROCEDURE DELETE_DETAILX; -- RESULT_MASTERX_DEL_D, RESULT_DETAILX_DEL_D
    PROCEDURE DELETE_MASTERX_DETAILX; -- RESULT_MASTERX_DEL_M_D, RESULT_DETAILX_DEL_M_D
END;
/

CREATE OR REPLACE PACKAGE BODY TABLEX_DATA_OPS IS
    PROCEDURE ADD_MASTERX IS
    BEGIN
        INSERT INTO MASTERX SELECT * FROM DATA_MASTERX_ADD_M;
    END;
    
    PROCEDURE ADD_DETAILX IS
    BEGIN
        INSERT INTO DETAILX SELECT * FROM DATA_DETAILX_ADD_D;
    END;
    
    PROCEDURE ADD_MASTERX_DETAILX IS
    BEGIN
        INSERT INTO MASTERX SELECT * FROM DATA_MASTERX_ADD_M_D;
        INSERT INTO DETAILX SELECT * FROM DATA_DETAILX_ADD_M_D;
    END;
    
    PROCEDURE CHANGE_MASTERX IS
    BEGIN
        MERGE INTO MASTERX DEST
            USING (SELECT * FROM DATA_MASTERX_CHG_M) SRC
            ON (DEST.MASTERX_ID = SRC.MASTERX_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.MXC1 = SRC.MXC1,
                DEST.MXC2 = SRC.MXC2,
                DEST.MXC3 = SRC.MXC3,
                DEST.MXC4 = SRC.MXC4;
    END;
    
    PROCEDURE CHANGE_DETAILX IS
    BEGIN
        MERGE INTO DETAILX DEST
            USING (SELECT * FROM DATA_DETAILX_CHG_D) SRC
            ON (DEST.DETAILX_ID = SRC.DETAILX_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.DXC1 = SRC.DXC1,
                DEST.DXC2 = SRC.DXC2,
                DEST.DXC3 = SRC.DXC3;
    END;
    
    PROCEDURE CHANGE_MASTERX_DETAILX IS
    BEGIN
        MERGE INTO MASTERX DEST
            USING (SELECT * FROM DATA_MASTERX_CHG_M_D) SRC
            ON (DEST.MASTERX_ID = SRC.MASTERX_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.MXC1 = SRC.MXC1,
                DEST.MXC2 = SRC.MXC2,
                DEST.MXC3 = SRC.MXC3,
                DEST.MXC4 = SRC.MXC4;
        MERGE INTO DETAILX DEST
            USING (SELECT * FROM DATA_DETAILX_CHG_M_D) SRC
            ON (DEST.DETAILX_ID = SRC.DETAILX_ID)
            WHEN MATCHED THEN UPDATE SET 
                DEST.DXC1 = SRC.DXC1,
                DEST.DXC2 = SRC.DXC2,
                DEST.DXC3 = SRC.DXC3;
    END;
    
    PROCEDURE DELETE_DETAILX IS
    BEGIN
        DELETE FROM DETAILX
        WHERE
            DETAILX_ID IN (SELECT DETAILX_ID FROM DATA_DETAILX_DEL_D);
    END;
    
    PROCEDURE DELETE_MASTERX_DETAILX IS
    BEGIN
        DELETE FROM MASTERX
        WHERE
            MASTERX_ID IN (SELECT MASTERX_ID FROM DATA_MASTERX_DEL_M_D);
    END;    
END;
/

--------------------------------------------------------------------------------
-- TABLES WITH COMPLEX TYPES COMPARISON OPERATIONS
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION FLATTEN_SQL_VARR(VA SQL_VARR) RETURN VARCHAR2 IS
    RESULT VARCHAR2(32767);
BEGIN
    FOR I IN 1..VA.LAST
    LOOP
        IF RESULT IS NULL
        THEN
            RESULT := VA(I);
        ELSE
            RESULT := RESULT || '|' || VA(I);
        END IF;
    END LOOP;
    RETURN RESULT;
END;
/

CREATE OR REPLACE PROCEDURE COMPARE_MASTERX_TABLES(TABLE_A VARCHAR2, TABLE_B VARCHAR2)
IS
    TYPE RC_T IS REF CURSOR;
    RC RC_T;
    STMT VARCHAR2(1024);
    ROW_COUNT NUMBER;
BEGIN
    STMT := 
        'SELECT COUNT(*) FROM ( ( ' ||
    '    SELECT M.MASTERX_ID, M.MXC1, M.MXC2, FLATTEN_SQL_VARR(M.MXC3), M.MXC4.OBJ_1, M.MXC4.OBJ_2 FROM ' || TABLE_A || ' M ' ||
        '    MINUS ' ||
    '    SELECT M.MASTERX_ID, M.MXC1, M.MXC2, FLATTEN_SQL_VARR(M.MXC3), M.MXC4.OBJ_1, M.MXC4.OBJ_2 FROM ' || TABLE_B || ' M ' ||
        ') UNION ALL ( ' ||
    '    SELECT M.MASTERX_ID, M.MXC1, M.MXC2, FLATTEN_SQL_VARR(M.MXC3), M.MXC4.OBJ_1, M.MXC4.OBJ_2 FROM ' || TABLE_B || ' M ' ||
        '    MINUS ' ||
    '    SELECT M.MASTERX_ID, M.MXC1, M.MXC2, FLATTEN_SQL_VARR(M.MXC3), M.MXC4.OBJ_1, M.MXC4.OBJ_2 FROM ' || TABLE_A || ' M ' ||
        ') )';
    OPEN RC FOR STMT;
    FETCH RC INTO ROW_COUNT;
    CLOSE RC;
    IF ROW_COUNT <> 0
    THEN
        RAISE_APPLICATION_ERROR(-20001, 'MASTERX TABLES DIFFER: ' || TABLE_A || ' AND ' || TABLE_B);
    END IF;
END;
/

CREATE OR REPLACE PROCEDURE COMPARE_DETAILX_TABLES(TABLE_A VARCHAR2, TABLE_B VARCHAR2)
IS
    TYPE RC_T IS REF CURSOR;
    RC RC_T;
    STMT VARCHAR2(1024);
    ROW_COUNT NUMBER;
BEGIN
    STMT := 
        'SELECT COUNT(*) FROM ( ( ' ||
    '    SELECT D.DETAILX_ID, D.MASTERX_ID, D.DXC1, TO_CHAR(D.DXC2), D.DXC3 FROM ' || TABLE_A || ' D ' ||
        '    MINUS ' ||
    '    SELECT D.DETAILX_ID, D.MASTERX_ID, D.DXC1, TO_CHAR(D.DXC2), D.DXC3 FROM ' || TABLE_B || ' D ' ||
        ') UNION ALL ( ' ||
    '    SELECT D.DETAILX_ID, D.MASTERX_ID, D.DXC1, TO_CHAR(D.DXC2), D.DXC3 FROM ' || TABLE_B || ' D ' ||
        '    MINUS ' ||
    '    SELECT D.DETAILX_ID, D.MASTERX_ID, D.DXC1, TO_CHAR(D.DXC2), D.DXC3 FROM ' || TABLE_A || ' D ' ||
        ') )';
    OPEN RC FOR STMT;
    FETCH RC INTO ROW_COUNT;
    CLOSE RC;
    IF ROW_COUNT <> 0
    THEN
        RAISE_APPLICATION_ERROR(-20001, 'DETAILX TABLES DIFFER: ' || TABLE_A || ' AND ' || TABLE_B);
    END IF;
END;
/

--------------------------------------------------------------------------------
-- VERIFY TEST OPERATIONS USING TABLES WITH COMPLEX TYPES YIELD EXPECTED RESULTS
--------------------------------------------------------------------------------

BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.ADD_MASTERX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_ADD_M');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_ADD_M');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.ADD_DETAILX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_ADD_D');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_ADD_D');
    COMMIT;
END;
/
            
BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.ADD_MASTERX_DETAILX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_ADD_M_D');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_ADD_M_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.CHANGE_MASTERX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_CHG_M');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_CHG_M');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.CHANGE_DETAILX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_CHG_D');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_CHG_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.CHANGE_MASTERX_DETAILX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_CHG_M_D');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_CHG_M_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.DELETE_DETAILX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_DEL_D');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_DEL_D');
    COMMIT;
END;
/

BEGIN
    SETUP_TABLEX_DATA;
    TABLEX_DATA_OPS.DELETE_MASTERX_DETAILX;
    COMPARE_MASTERX_TABLES('MASTERX', 'RESULT_MASTERX_DEL_M_D');
    COMPARE_DETAILX_TABLES('DETAILX', 'RESULT_DETAILX_DEL_M_D');
    COMMIT;
END;
/

DELETE FROM MASTERX;
COMMIT;

--------------------------------------------------------------------------------
-- SIMPLE MESSAGE LOGGING
--------------------------------------------------------------------------------

begin
  execute immediate 'DROP TABLE TEST_MESSAGE_LOGS';
exception
  when others
  then
    if sqlcode <> -942
    then
      raise;
    end if;
end;
/

CREATE TABLE TEST_MESSAGE_LOGS (
    TS TIMESTAMP,
    MESSAGE VARCHAR2(256)
);    

CREATE OR REPLACE PROCEDURE LOG_TEST_MESSAGE(MESSAGE VARCHAR2)
IS
    PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
    INSERT INTO TEST_MESSAGE_LOGS VALUES (SYSTIMESTAMP, MESSAGE);
    COMMIT;
END;
/
