create analytic workspace galter39;

create cube dimension channel39 
(level1 level, level2 level, level3 level,
hierarchy1 hierarchy (level1 child of level2),
hierarchy2 hierarchy (level2 child of level3))
analytic workspace galter39;

create cube dimension time39 
("MONTH" level, calendar_quarter level, calendar_year level, fiscal_quarter level, fiscal_year level,
calendar hierarchy ("MONTH" child of calendar_quarter child of calendar_year),
fiscal hierarchy ("MONTH" child of fiscal_quarter child of fiscal_year))
analytic workspace galter39;

create cube dimension channel39A
(level1 level, level2 level, level3 level,
hierarchy1 hierarchy (level1 child of level2))
analytic workspace galter39;

create cube units40
(
  channel39 dimension sparse,
  sales measure ALLOWAUTODATATYPECHANGE number,
  cost measure ALLOWAUTODATATYPECHANGE number
)
sparsetype compressed measurestorage independent
analytic workspace galter39;

create cube units40storage
(
  channel39 dimension sparse,
  sales measure ALLOWAUTODATATYPECHANGE number,
  cost measure ALLOWAUTODATATYPECHANGE number
)
sparsetype compressed measurestorage independent
analytic workspace galter39;

alter cube units40storage sparsetype sparse measurestorage independent;

drop cube units40storage;

alter cube units40 rename to units41;

alter cube units41 rename measure sales to sales2;

alter cube units41 add (cost measure ALLOWAUTODATATYPECHANGE number, units measure ALLOWAUTODATATYPECHANGE number, time39 dimension sparse);

alter cube units41 drop (cost, time39 dimension);

alter cube units41 add (cost measure, channel39A dimension sparse, time39 dimension sparse);

alter cube units41 drop (channel39A dimension, time39 dimension);

alter cube units41 set (channel39A dimension, time39 dimension);

drop cube units41;

drop cube dimension channel39A;

create cube units39
(
  channel39 dimension sparse,
  time39 dimension sparse,
  sales measure ALLOWAUTODATATYPECHANGE number,
  cost measure ALLOWAUTODATATYPECHANGE number
)
analytic workspace galter39;

alter cube units39 partition ( 
  time39 by calendar_quarter for calendar precompute percent 40
, time39 by fiscal_quarter for fiscal precompute percent 40
);

alter cube units39 partition ( );

alter cube units39 partition ( time39 by calendar_quarter for calendar precompute percent 40 );

drop cube units39;

drop cube dimension channel40;

drop cube dimension time39;

alter cube dimension channel39 modify ( hierarchy1 hierarchy drop ( level1 level ) );

alter cube dimension channel39 drop (level1 level);

select level_name from all_cube_hier_levels where dimension_name = 'CHANNEL39' and hierarchy_name = 'HIERARCHY1' order by order_num;

alter cube dimension channel39 add (level1 level);

alter cube dimension channel39 add (level4 level);

alter cube dimension channel39 modify ( 
   hierarchy1 hierarchy from level2 set level1 child of level2,
   hierarchy2 hierarchy from level2 child of level3 set level1 child of level2 child of level3 child of level4) ;

select level_name from all_cube_hier_levels where dimension_name = 'CHANNEL39' and hierarchy_name = 'HIERARCHY1' order by order_num;

alter cube dimension channel39 add ( hierarchy3 hierarchy ( level1 child of level2 ) );

alter cube dimension channel39 rename to channel40;

alter cube dimension channel40 rename level level1 to level1a;

alter cube dimension channel40 rename hierarchy hierarchy1 to hierarchy1a;

select level_name from all_cube_dim_levels where dimension_name = 'CHANNEL40' and level_name = 'LEVEL1A';

drop cube dimension channel40;

create cube dimension channel41 (valuehier1 hierarchy)
analytic workspace galter39;

select hierarchy_name from all_cube_hierarchies where dimension_name = 'CHANNEL41' and hierarchy_name = 'VALUEHIER1';

alter cube dimension channel41 rename hierarchy valuehier1 to valuehier1a;

select hierarchy_name from all_cube_hierarchies where dimension_name = 'CHANNEL41' and hierarchy_name = 'VALUEHIER1A';

drop cube dimension channel41;

create cube dimension test1 ( level1 level) 
classifications ( 'DimensionType'='MEASURE' )
analytic workspace galter39;

alter cube dimension test1 classifications ( 'DimensionType'='MEASURE' );

alter cube dimension test1 DROP classifications ( 'DimensionType'='MEASURE' );

drop cube dimension test1;

drop analytic workspace galter39;
